# panda3d community copy.
# Panda3d Library: these sentences loads defined functions from python scripts
# under the panda3d library providing features and functions from panda3d.
# this loads the visual functions from panda3d into python.
from direct.showbase.ShowBase import ShowBase
# this loads the lighting functions from panda3d into python.
from panda3d.core import Filename, AmbientLight, DirectionalLight
# this loads camera funcations from panda3d into python
from panda3d.core import PandaNode, NodePath, Camera, TextNode
# this loads text functions from panda3d into python.
from direct.gui.OnscreenText import OnscreenText
# this loads the panda3d task manager into pyrhon.
from direct.task import Task
# this loads the animation funcations from panda3d into python.
from direct.actor.Actor import Actor
# imports low level functalty
from direct.showbase.DirectObject import DirectObject
# imports advanced functionalty
from direct.interval.IntervalGlobal import Sequence, Func, Wait
# this loads the collision detection logic from panda3d.
from panda3d.core import CollisionTraverser, CollisionHandlerPusher, CollisionHandlerEvent
from panda3d.core import CollisionNode, CollisionSphere, CollisionTube
# imports functalty for number formats suportting tuples.
from panda3d.core import Point3
from panda3d.core import Vec3
from panda3d.core import LVector3
# this imports visiablity functioanlty from the panda3d library.
from panda3d.core import TransparencyAttrib
# this loads in A.I functionalty from panda3d
from panda3d.ai import *
# this loads other functions not nativly suportted by python
import random
import sys
import os
import math
from panda3d.core import PandaSystem
# this loads in the filtering function not in suported in python.
import re
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Game
# - - -
# Load List: a filepath to a model is assigned to a interger (defined model)
scene1 = "room/room000.egg"
actor1 = "actor/charatest.egg"
#mmain = "bgm/dummy_background.wav"
# - - -
# Game state variables
mvol = 0.1
svol = 0.1
run = True
blue = True
pause = False
nse = 0
rng = 0
seed = [0, 0, 0]
# Character state variables
character = 0
cactor1 = 0
cactor2 = 0
charaset = 1
charastart = False
dummydel = 0
dumcom = False
shinny = False
swimming = False
soar = False
splash = False
floating = False
suspended = False
suspended2 = False
thmset = True
thmready = False
# Movment Variables: used for features to track movement.
norpar = 0.0
nwpar = 0.0
wespar = 0.0
swpar = 0.0
soupar = 0.0
separ = 0.0
easpar = 0.0
nepar = 0.0
camlock = False
camset = False
chuck = False
flingdel = 0
fling = False
facing = 0.0
forward = False
notdir = True
celerity = [True, True, True, True, True, True, True, True, True, True]
slddel = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
vel = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
spd = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
sld = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
mvt = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
mom = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
mag = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
rpos = [0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1, 0.1]
rneg = [-0.1, -0.1, -0.1, -0.1, -0.1, -0.1, -0.1, -0.1, -0.1, -0.1]
surcrp = 0
actcrp = 0
stpcrp = 0
crpdel = 0
creeping = False
edge = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
# jump variables
jmpstm = True
jmpdel = 0
polejmp = False
pjmp = -1
# falling variables
prepos = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
pospos = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
falling = False
slam = False
splat = False
# marching variables
step = True
letgo = False
CamPar = 2.0
look = False
camscn = False
camseq = [0, 0, 0]
dip = 0
stp = 0
# health varibles
damage = False
hurt = 0
hurtdel = 0
bounce = [False, False, False, False, False, False, False, False, False, False]
HP = [3, 3, 3, 3, 3, 3, 3, 3, 3, 3]
# surface varibles
frict = [False, False, False, False, False, False, False, False, False, False]
land = False
surZ = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
surfP = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
selfrwd = 0
surfY = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
slipping = False
sliding = False
bump = False
relp = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
surf = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
# interact variables
curline = "!"
iactline0 = "A"
iactline1 = "B"
iactline2 = "C"
iactline3 = "D"
iactline4 = "E"
iactline5 = "F"
iactline6 = "G"
iactline7  = "H"
iactline8 = "I"
iactline9 = "J"
interact = False
inactset = False
inactobj = False
inactitm = False
iactline = 0
interacting = False
textdel = 0
iaforward = 0
iaup = 0
iactend = 0
tspd = -60
switch = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
frlst = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
delay = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
tou = [False, False, False, False, False, False, False, False]
grab = False
pick = 0
np = 0
sequence = [0, 0, 0]
charcrp = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
see = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
crp = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
suspect = [False, False, False, False, False, False, False, False, False, False]
suspected = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
suspos = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
din = 0
noise = 0
nseset = False
chase = [False, False, False, False, False, False, False, False, False, False]
tap = [False, False, False, False, False, False, False, False, False, False]
attend = [False, False, False, False, False, False, False, False, False, False]
appro = [False, False, False, False, False, False, False, False, False, False]
seen = [False, False, False, False, False, False, False, False, False, False]
seqact = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
pathset = [False, False, False, False, False, False, False, False, False, False]
wondel = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
pid = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
pseed1 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
pseed2 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
perimeter = [False, False, False, False, False, False, False, False, False, False]
wontrn = [False, False, False, False, False, False, False, False, False, False]
# animating variables
bgm = 0
state = 0
sndste = 0
aplay = False
playdel = 0
plylim = 0
ascript = False
aslist = 0
actplay = 0
sct = 0
lock = False
actdel = False
leap = False
dive = 0
brake = False
climbing = False
poleleap = False
swervew = False
swervee = False
slide = False
slip = False
sct1 = False
sct2 = False
impact = False
reading = False
# debugging variables
debug = False
room = 0
# - - -
# Game System: controls all the logic for the game.
class gamesys(ShowBase):

    def __init__(self):
        ShowBase.__init__(self)
        
# - Model (Visual) Functions -        
# Loads the model defined as the background environment, and reparents the model to
# render, finally sets the postion of the rendered background.
        self.scene = self.loader.loadModel(scene1)
        scnwater = self.scene.find("**/water")
        scnwater.setAlphaScale(0.5)
        scnwater.setTransparency(TransparencyAttrib.M_alpha)         
        self.scene.reparentTo(self.render)
        self.scene.setPos(0, 0, 0)

# the task that handles what character the player is.
        global cactor1
        global cactor2
        cactor1 = Actor("actor/opptest.egg")
        self.pactor = cactor1
        self.pactor.reparentTo(self.render) 
        self.srtpos = self.scene.find("**/start").getPos()       
        self.pactor.setPos(self.srtpos + (0.0, 0.0, 6.3))               

        self.taskMgr.add(self.character, "characterTask")
        
# - Sounds And Visuals Task -            
#        self.taskMgr.add(self.animation, "animateTask")

# - Audio Functions -
#        self.bgm_main = self.loader.loadMusic(mmain)
#        self.sfxHop = self.loader.loadSfx("sfx/hop.wav")
#        self.sfxLand = self.loader.loadSfx("sfx/land.wav")
#        self.sfxShiny = self.loader.loadSfx("sfx/shiny.wav")
#        self.sfxSplash = self.loader.loadSfx("sfx/splash.wav")
#        self.sfxStep = self.loader.loadSfx("sfx/step.wav")
#        self.sfxSwim = self.loader.loadSfx("sfx/swim.wav")        
#        self.sfxSwimming = self.loader.loadSfx("sfx/swimming.wav")

# - Audio Volume -
#        global mvol
#        global svol
#        self.bgm_main.setVolume(mvol)
#        self.sfxHop.setVolume(svol)
#        self.sfxLand.setVolume(svol)
#        self.sfxShiny.setVolume(svol)
#        self.sfxSplash.setVolume(svol)
#        self.sfxStep.setVolume(svol)
#        self.sfxSwim.setVolume(svol)       
#        self.sfxSwimming.setVolume(svol)
        
# - Camera Functions -
# Disable the camera (default) trackball controls, and allows the camera to be
# moved around the player.
        self.disableMouse()
        self.camera.setPos(self.pactor.getX(), self.pactor.getY() + 10, 6)
        
# this creates a target for the cmaera to focus on.
        self.camtarget = NodePath(PandaNode("ctarget"))
        self.camtarget.reparentTo(self.pactor)
        self.camtarget.setZ(2.0)       

# - Theme Functions -
# this set up the theme variables from a function named "theme" which should
# exist on each level script.
        self.taskMgr.add(self.theme, "themeTask")

# - Control (Keyboard) Functions -
        self.keyMap = {"north": 0, "east": 0, "south": 0, "west": 0, "ishop": 0, "zoomin": 0, "zoomout": 0, "cambob": 0, "camweave": 0, "creep": 0}

# keys when held down.       
        self.accept("arrow_up", self.satKey, ["north", True])
        self.accept("arrow_down", self.satKey, ["south", True])
        self.accept("arrow_left", self.satKey, ["west", True])
        self.accept("arrow_right", self.satKey, ["east", True])
        self.accept("j", self.satKey, ["ishop", True])
        self.accept("a", self.satKey, ["cambob", True])
        self.accept("d", self.satKey, ["camweave", True])
        self.accept("w", self.satKey, ["zoomin", True])
        self.accept("x", self.satKey, ["zoomout", True])        
        self.accept("c", self.satKey, ["creep", True])
        
# keys when released.        
        self.accept("arrow_up-up", self.satKey, ["north", False])
        self.accept("arrow_down-up", self.satKey, ["south", False])
        self.accept("arrow_left-up", self.satKey, ["west", False])
        self.accept("arrow_right-up", self.satKey, ["east", False])
        self.accept("j-up", self.satKey, ["ishop", False])
        self.accept("a-up", self.satKey, ["cambob", False])
        self.accept("d-up", self.satKey, ["camweave", False])
        self.accept("w-up", self.satKey, ["zoomin", False])
        self.accept("x-up", self.satKey, ["zoomout", False])
        self.accept("c-up", self.satKey, ["creep", False])
        
# these plays out whatever is defined (def) every frame, in this case the
# the movement functions.       
        self.taskMgr.add(self.move, "moveTask")
        self.taskMgr.add(self.speed, "velocityTask")

# - Collision Functions -

# the collision traverser scans everything for stuff (handlers) constintly so
# that when the time comes when something meets another thing, the traverser
# already knows and can return a value based on the handlers assigned to those
# somethings.
# this  creates delcares a self variable as a Collision Handler, then adds
# logic under it. there is also a thershold limit of 5 models up to 6,400 tris
# each and a scene up to 8,000 tris on screen at a time (7th gen game).
# this handler is for the floor, walls, and celing.                                       
        base.cTrav = CollisionTraverser()
        self.pusher = CollisionHandlerPusher()
# this below records the prevous postion just in case reverting        
        base.cTrav.setRespectPrevTransform(True)

# Create a collsion node this object (the player), models are supposed to have
# them written in using blender's logic editor, where they are loaded with said
# silently and invisalbe, but in cases of living objects a collision sphere is
# created for them like below, this attaches a new collsion node (model) to
# the player's model which is "model piece (blender)" named in green.
        self.actor1cn = NodePath(CollisionNode('player'))
        self.actor1cn.reparentTo(self.pactor) 
# defines the attached above collison model as a collision sphere.
        self.actor1cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
# this below adds a collider to the traverser system using the stated object
# (which is the player's sphere) as the tool for that added collider making
# the said object a "From" object and eveyhting else a "Into" object.
        base.cTrav.addCollider(self.actor1cn, self.pusher)
        self.pusher.addCollider(self.actor1cn, self.pactor)
        self.pobject = self.pactor

# this defines how two objects collide (collision's conditions between two
# objects).        
        self.pusher.addAgainPattern('%fn-again-%in')
        self.pusher.addOutPattern('%fn-out-%in')
        self.pusher.addAgainPattern('%fn-again-%fn')
        self.pusher.addOutPattern('%fn-out-%fn')        
        
        self.accept("player-again-slope", self.surface)
        self.accept("player-again-plane", self.surface)
        self.accept("player-out-plane", self.airborn)
        self.accept("player-again-pole", self.shin)
        self.accept("player-again-polecap", self.shinletgo)
        self.accept("player-again-scnev1", self.sign)
        self.accept("player-out-scnev1", self.leaveinact)       
        self.accept("player-again-water", self.dipin)
        self.accept("player-out-water", self.dipout)
        self.accept("player-again-fr1", self.grab)
        self.accept("player-out-fr1", self.leaveinact)        
        self.accept("fr1-again-plane", self.frsurf)
        self.accept("player-again-fr3", self.touch)
        self.accept("player-again-fr4", self.touch)
        self.accept("player-again-camscn1", self.camscn01)
        self.accept("player-out-camscn1", self.camrtn)
        self.accept("vi2-again-atttar2", self.attention)
        self.accept("fr2-again-atttar2", self.approach)        
        self.accept("fr2-again-plane", self.frsurf)
        self.accept("player-again-vi2", self.encounter)
        self.accept("player-out-vi2", self.evade)
        self.accept("vi7-again-atttar7", self.attention)
        self.accept("fr7-again-atttar7", self.approach)
        self.accept("fr7-again-plane", self.frsurf)
        self.accept("player-again-vi7", self.encounter)
        self.accept("player-out-vi7", self.evade)
        self.accept("fr8-again-seqtar8", self.pathfollow)
        self.accept("vi8-again-atttar8", self.attention)
        self.accept("fr8-again-atttar8", self.approach)        
        self.accept("fr8-again-plane", self.frsurf)
        self.accept("player-again-vi8", self.encounter)
        self.accept("player-out-vi8", self.evade)
        self.accept("fr9-again-pe9", self.perimeter)
        self.accept("fr9-out-pe9", self.border)
        self.accept("fr9-again-plane", self.frsurf)
        self.accept("fr1-again-atttar1", self.approach)
        self.accept("player-again-fr2", self.hit)
        
# - Interaction _
        self.interactline = TextNode("interact")                     
        ialine = aspect2d.attachNewNode(self.interactline)        
        ialine.setScale(0.10)
        ialine.setPos(-1.3, 0.00, -0.90)
        self.interactline.setShadow(0.05, 0.05)
        self.interactline.setShadowColor(0, 0, 0, 1)

# task that controls the in game text.
        self.taskMgr.add(self.interact, "textTask")
        self.taskMgr.add(self.dummydelay, "ddelayTask")

# task that controls the noise functions (stealth).        
        self.taskMgr.add(self.noise, "noiseTask")

# task that manages health delivery and dealing
        self.taskMgr.add(self.damage, "healthTask")
        
# From Objects.
        self.taskMgr.add(self.fr01, "From Obj 1")
        self.taskMgr.add(self.fr02, "From Obj 2")
        self.taskMgr.add(self.fr03, "From Obj 3")
        self.taskMgr.add(self.fr04, "From Obj 4")
        self.taskMgr.add(self.fr05, "From Obj 5")        
# Into Objects.
        self.taskMgr.add(self.in02, "Into Obj 1") 
        self.taskMgr.add(self.in03, "Into Obj 2")
        self.taskMgr.add(self.in04, "Into Obj 3")
        self.taskMgr.add(self.in05, "Into Obj 4")
        
# Random Number Generator
        self.taskMgr.add(self.rng, "R.N.G.Task")
# - Debugging -
        if debug:
# this creates a node for the debug line which is called on later
           self.debugline1 = TextNode("line1")              
# this adds the node to the 2d plane.        
           dgline1 = aspect2d.attachNewNode(self.debugline1)
# this sets the size and position of the text.        
           dgline1.setScale(0.05)
           dgline1.setPos(-1.3, 0.00, 0.9)

# line 2.
           self.debugline2 = TextNode("line2")                     
           dgline2 = aspect2d.attachNewNode(self.debugline2)        
           dgline2.setScale(0.05)
           dgline2.setPos(-1.3, 0.00, 0.8)

        
# line 3.
           self.debugline3 = TextNode("line3")                    
           dgline3 = aspect2d.attachNewNode(self.debugline3)        
           dgline3.setScale(0.05)
           dgline3.setPos(-1.3, 0.00, 0.7)

# line 4.
           self.debugline4 = TextNode("line4")                     
           dgline4 = aspect2d.attachNewNode(self.debugline4)        
           dgline4.setScale(0.05)
           dgline4.setPos(-1.3, 0.00, 0.6)

# line 5.
           self.debugline5 = TextNode("line5")                    
           dgline5 = aspect2d.attachNewNode(self.debugline5)        
           dgline5.setScale(0.05)
           dgline5.setPos(-1.3, 0.00, 0.5)
        
# line 6.
           self.debugline6 = TextNode("line6")                    
           dgline6 = aspect2d.attachNewNode(self.debugline6)        
           dgline6.setScale(0.05)
           dgline6.setPos(-1.3, 0.00, 0.4)

# this shows all the collisions (debugging)        
           base.cTrav.showCollisions(render)
# Set the object's collison node to render as visible (debugging).
           self.actor1cn.show()

# this task updates the text with changing varibles
           self.taskMgr.add(self.debugupdate, "debugTask")

# defined functions for this class - - - - - - - - - - - - - - - - - - - - - -
    def satKey(self, key, value):
        self.keyMap[key] = value

    def character(self, task):
        global character
        global charaset
        global charastart
        global cactor2
        global cactor1
        global run
        if character is 0:
            if not charaset is character:
                if run:                  
                    run = False                  
                else:
                    cactor2 = Actor("actor/charatest.egg", {"Brake": "actor/charatest-ani/Brake.egg", 
                    "Collide": "actor/charatest-ani/Collide.egg", "CollideMove": "actor/charatest-ani/CollideMove.egg",
                    "Fall": "actor/charatest-ani/Fall.egg", "HardLand": "actor/charatest-ani/HardLand.egg",
                    "Jump": "actor/charatest-ani/Jump.egg", "LandRec": "actor/charatest-ani/LandRec.egg",
                    "NormLand": "actor/charatest-ani/NormLand.egg", "ShiftFlipHV": "actor/charatest-ani/ShiftFlipHV.egg",
                    "ShiftFlipVH": "actor/charatest-ani/ShiftFlipVH.egg", "ShinnyDown": "actor/charatest-ani/ShinnyDown.egg",
                    "ShinnyUp": "actor/charatest-ani/ShinnyUp.egg", "SlideBelly": "actor/charatest-ani/SlideBelly.egg",
                    "SlideBRec": "actor/charatest-ani/SlideBRec.egg","SlideBTRec": "actor/charatest-ani/SlideBTRec.egg",
                    "SlideButt": "actor/charatest-ani/SlideButt.egg", "Stand": "actor/charatest-ani/Stand.egg",
                    "SwimForward": "actor/charatest-ani/SwimForward.egg", "SwimLeft": "actor/charatest-ani/SwimLeft.egg",
                    "SwimRight": "actor/charatest-ani/SwimRight.egg", "SwimStill": "actor/charatest-ani/SwimStill.egg",
                    "Walk": "actor/charatest-ani/Walk.egg"})
                    self.pequip = cactor2.exposeJoint(None, 'modelRoot', 'Body')
                    bound = self.pactor.node().getBounds()
                    self.pactor = cactor2
                    self.camtarget.reparentTo(self.pactor)
                    self.actor1cn.reparentTo(self.pactor)
#                    self.pactor.node().setBounds(bound)
#                    self.pactor.node().setFinal(True)
                    charaset = 0
            else:
                run = True

        if not charastart:
#            pactor.reparentTo(self.render) 
#            self.srtpos = self.scene.find("**/start").getPos()       
#            self.pactor.setPos(self.srtpos + (0.0, 0.0, 6.3))
            charastart = True
            
        return Task.cont
        
    def grab(self, entry):
        global inactitm
        global interact
        global pick
        global frlst
        global grab
        global fling
        global run
        if run:
            if not grab:
                frids = re.compile('\d+(?:\.\d+)?')
                frid = frids.findall(str(entry.getIntoNodePath()))
                if not fling:
                    interact = True
                    inactitm = True            
                    pick = frlst[int(frid[0])]              

    def touch(self, entry):
        global tou
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getIntoNodePath()))
            tou[int(frid[0])] = True

    def encounter(self, entry):
        global see
        global seen
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getIntoNodePath()))
            if see[int(frid[0])] == entry.getInto():
                seen[int(frid[0])] = True

    def evade(self, entry):
        global see
        global seen
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getIntoNodePath()))       
            seen[int(frid[0])] = False                         

    def attention(self, entry):
        global attend
        global switch
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getFromNodePath()))
            if switch[int(frid[0])] > 0:
               attend[int(frid[0])] = True

    def approach(self, entry):    
        global appro
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getFromNodePath()))
            appro[int(frid[0])] = True

    def pathfollow(self, entry):
        global seqact
        global pathset
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getFromNodePath()))
            if not pathset[int(frid[0])]:
                pathset[int(frid[0])] = True
                seqact[int(frid[0])] += 1

    def perimeter(self, entry):
        global edge
        global perimeter
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getIntoNodePath()))
            if edge[int(frid[0])] == entry.getInto():
                perimeter[int(frid[0])] = True

    def border(self, entry):
        global edge
        global perimeter
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getIntoNodePath()))
            if edge[int(frid[0])] == entry.getInto():
                perimeter[int(frid[0])] = False             

    def hit(self, entry):
        global hurt
        global damage
        global leap
        global falling
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getIntoNodePath()))
            if not damage:
                if leap or falling:
                    hurt = int(frid[0])
                    damage = True 
                else:   
                    hurt = 0
                    damage = True         
                      
    def airborn(self, entry):
        global land
        global sliding
        global slipping
        global slip
        global slide
        global run
        if run:
            if sliding:
                slide = True    
                slipping = False
                sliding = False
                land = False
            elif slipping:
                slip = True    
                slipping = False
                sliding = False
                land = False
            else:
                slipping = False
                sliding = False
                land = False                       

    def dipin(self, entry):
        global dip
        global run
        if run:
            dip = self.pactor.getZ()
        
    def dipout(self, entry):
        global dip
        global swimming
        global splash
        global dive
        global run
        if run:
            if self.pactor.getZ() > dip:
                swimming = False
                splash = True
            else:
                swimming = True
                dive = 0
                splash = True
       
    def shin(self, entry):
        global shinny
        global polejmp
        global pjmp
        global letgo
        global run
        if run:
            letgo = False
            polejmp = False
            pjmp = 0
            colPoint = self.render.getRelativePoint(self.pobject, (0, 1, 0))
            faVec = entry.getSurfaceNormal(self.render)       
            self.pobject.lookAt(colPoint + faVec)
            shinny = True

    def shinletgo(self, entry):
        global letgo
        global run
        if run:
            letgo = True

    def grip(self, entry):
        global lock
        global look
        global run
        if run:
            look = True
            lock = True

    def animation(self, task):
        global state
        global sndste        
        global aplay
        global playdel
        global plylim
        global ascript
        global actplay
        global aslist
        global sct
        global look
        global lock
        global forward
        global leap
        global land
        global swimming
        global dive
        global sliding
        global slipping
        global shinny
        global falling
        global brake
        global climbing
        global swervew
        global swervee
        global bump
        global slip
        global slide
        global saor
        global sct1
        global sct2
        global impact
        global inactset
        global splash
        global reading
        global bgm
        global charaset
        global character        
        global run
        
        if run:
            if not bgm is 1:
               self.bgm_main.setLoop(True)
               self.bgm_main.play()
               bgm = 1   
            
            if not aplay:                
                if forward and not leap and not shinny and not bump and not swimming and not soar:
                    if not state is 1:
                        self.pactor.loop("Walk")
                        state = 1
                        if not falling:
                            if not sndste is 1:
                                self.sfxStep.setLoop(True)
                                self.sfxStep.play()
                                sndste = 1

                if land and not forward and not bump and not slipping and not soar:
                    if not state is 2:
                        self.pactor.loop("Stand")
                        state = 2
                        sndste = 0

                if swimming and dive is 0:
                    if not state is 3:
                        self.pactor.loop("SwimStill")
                        state = 3
                        if not sndste is 2:
                            self.sfxSwim.setLoop(True)
                            self.sfxSwim.play()
                            sndste = 2

                if sliding and slipping and not bump and not leap and not swimming and not soar:
                    if not state is 4:
                        self.pactor.loop("SlideBelly")
                        state = 4
    #                    if not sndste is 3:
    #                        self.sfxSlide.setLoop(True)
    #                        self.sfxSlide.play()
    #                        sndste = 3

                if falling and not land and not swimming and not soar:
                    if not state is 5:
                        self.pactor.loop("Fall")
                        state = 5

                if leap and not soar:
                    if not state is 6:
                        self.pactor.loop("Jump")                   
                        state = 6
                        if not sndste is 4:
                           self.sfxHop.play()
                           sndste = 4
                        

                if shinny and not climbing:
                    if not state is 7:
                        self.pactor.loop("ShinnyDown")                   
                        state = 7
                        sndste = 0

                if climbing and shinny:
                    if not state is 8:
                        self.pactor.loop("ShinnyUp")                   
                        state = 8
                        if not sndste is 5:
                           self.sfxShiny.setLoop(True)
                           self.sfxShiny.play()
                           sndste = 5

                if dive is 2 and swimming and not swervew and not swervee:
                    if not state is 9:
                        self.pactor.loop("SwimForward")                    
                        state = 9
                        if not sndste is 6:
                           self.sfxSwimming.setLoop(True)
                           self.sfxSwimming.play()
                           sndste = 6

                if swervew and swimming and dive is 2:
                    if not state is 10:
                        self.pactor.loop("SwimLeft")
                        state = 10                    
                        if not sndste is 6:
                           self.sfxSwimming.setLoop(True)
                           self.sfxSwimming.play()
                           sndste = 6

                        
                if swervee and swimming and dive is 2:
                    if not state is 11:
                        self.pactor.loop("SwimRight")                    
                        state = 11
                        if not sndste is 6:
                           self.sfxSwimming.setLoop(True)
                           self.sfxSwimming.play()
                           sndste = 6

                if slipping and not bump and not leap and not swimming and not soar:
                    if not state is 12:
                        self.pactor.loop("SlideButt")                   
                        state = 12
    #                    if not sndste is 3:
    #                       self.sfxSlide.setLoop(True)
    #                       self.sfxSlide.play()
    #                       sndste = 3

                if brake and forward:
                    if not state is 13:
                        self.pactor.play("Brake")
                        plylim = 11
                        aplay = True
                        state = 13                    
                        sndste = 0
                        
                if slide:
                    if not state is 14:
                        self.pactor.play("SlideBRec")
                        plylim = 11
                        aplay = True 
                        state = 14

                if slip:
                    if not state is 14:
                        self.pactor.play("SlideBTRec")
                        plylim = 11
                        aplay = True 
                        state = 14

                if bump and not forward and not swimming and not soar:
                    if not state is 15:
                        self.pactor.loop("Collide")
                        state = 15
                        sndste = 0

                if bump and forward and not swimming and not soar:
                    if not state is 16:
                        self.pactor.loop("CollideMove")                   
                        state = 16
                        if not sndste is 1:
                           self.sfxStep.setLoop(True)
                           self.sfxStep.play()
                           sndste = 1

                if sct1 and actplay is 1:
                    if not state is 17:
                        self.pactor.play("HardLand")
                        plylim = 11
                        aplay = True
                        sct = False
                        state = 17
                        if not sndste is 7:
                           self.sfxLand.play()
                           sndste = 7

                if sct1 and actplay is 2:
                    if not state is 18:
                        self.pactor.play("LandRec")
                        plylim = 11
                        aplay = True
                        sct = False
                        state = 18

                if sct2 and actplay is 1:
                    if not state is 19:
                        self.pactor.play("NormLand")                   
                        plylim = 11
                        aplay = True
                        sct = False
                        state = 19
                        if not sndste is 7:
                           self.sfxLand.play()
                           sndste = 7
                           
                if sct2 and actplay is 2:
                    if not state is 20:
                        self.pactor.play("SlideBTRec")
                        plylim = 11
                        aplay = True
                        sct = False
                        state = 20

                if dive is 1 and swimming:
                    if not state is 21:
                        self.pactor.play("ShiftFlipVH")
                        plylim = 22
                        aplay = True
                        state = 21

                if dive is 3 and swimming:
                    if not state is 22:
                        self.pactor.play("ShiftFlipHV")
                        plylim = 22
                        aplay = True
                        state = 22
                        
                if soar and dive is 0:
                    if not state is 3:
                        self.pactor.loop("SwimStill")
                        state = 3
                        if not sndste is 2:
                            self.sfxSwim.setLoop(True)
                            self.sfxSwim.play()
                            sndste = 2

                if dive is 2 and soar and not swervew and not swervee:
                    if not state is 9:
                        self.pactor.loop("SwimForward")                    
                        state = 9
                        if not sndste is 6:
                           self.sfxSwimming.setLoop(True)
                           self.sfxSwimming.play()
                           sndste = 6

                if soar and swervew and dive is 2:
                    if not state is 10:
                        self.pactor.loop("SwimLeft")
                        state = 10                    
                        if not sndste is 6:
                           self.sfxSwimming.setLoop(True)
                           self.sfxSwimming.play()
                           sndste = 6

                        
                if soar and swervee and dive is 2:
                    if not state is 11:
                        self.pactor.loop("SwimRight")                    
                        state = 11
                        if not sndste is 6:
                           self.sfxSwimming.setLoop(True)
                           self.sfxSwimming.play()
                           sndste = 6                        
                            
                if splash:
                    if not sndste is 8:
                        self.sfxSplash.play()
                        splash = False
                        sndste = 8
                    else:
                        splash = False
                        
    #            if reading:
    #                if not sndste is 9:
    #                    self.sfxMsgconf.play()
    #                    reading = False
    #                    sndste = 9

    #            if reading:
    #                if not sndste is 10:
    #                    self.sfxRead.play()
    #                    reading = False
    #                    sndste = 10
                        
                if ascript and not sct:                
                    if not actplay is aslist:                  
                           actplay += 1
                           look = True
                           lock = True
                           sct = True
                    else:
                           look = False
                           lock = False
                           aslist = 0
                           actplay = 0
                           ascript = False
                           sct1 = False
                           sct2 = False                   
                           
    # sound control - - - - - - - - - - - - -                   
                if not sndste is 4:
                    self.sfxHop.stop()
                if not sndste is 7:                
                    self.sfxLand.stop()
    #            if not sndste is 9:                
    #                self.sfxMsgconf.stop()
    #            if not sndste is 10:                
    #                self.sfxRead.stop()
                if not sndste is 5:
                    self.sfxShiny.setLoop(False)
                    self.sfxShiny.stop()
    #            if not sndste is 3:
    #                self.sfxSlide.setLoop(False)
    #                self.sfxSlide.stop()
                if not sndste is 8:                
                    self.sfxSplash.stop()
                if not sndste is 1:
                    self.sfxStep.setLoop(False)
                    self.sfxStep.stop()
                if not sndste is 2:
                    self.sfxSwim.setLoop(False)
                    self.sfxSwim.stop()
                if not sndste is 6:
                    self.sfxSwimming.setLoop(False)
                    self.sfxSwimming.stop()
    #            if not sndste is 0:                
    #                self.sfxVict.stop()         
                        
            else:
                if not playdel is plylim:
                    playdel += 1
                else:    
                    playdel = 0
                    plylim = 0
                    brake = False
                    slide = False
                    slip = False
                    aplay = False
                    
        if not character is charaset:
                    state = 0
                        
        return Task.cont

    def damage(self, task):
        global damage
        global hurt
        global frlst
        global bounce
        global HP
        global hurtdel
        global run
        if run:
            if damage:
               dt = globalClock.getDt()            
               if not hurtdel > 18:
                    if hurt is 0:
                        bounce[0] = True
                        self.pactor.lookAt(frlst[hurt])                         
                        self.pactor.setY(self.pactor, 3 * dt)
                        self.pactor.setZ(self.pactor, +3 * dt)
                        hurtdel += 1
                    else:
                        bounce[hurt] = True
                        frlst[hurt].lookAt(self.pactor)                        
                        frlst[hurt].setY(frlst[hurt], -3 * dt)
                        frlst[hurt].setZ(frlst[hurt], +3 * dt)
                        hurtdel += 1                    
               else:
                    if hurt is 0:
                        hurtdel = 0
                        bounce[0] = False                   
                        HP[0] -= 1
                        damage = False
                    else:
                        hurtdel = 0
                        bounce[hurt] = False                   
                        HP[hurt] -= 1
                        damage = False

        return Task.cont                    
        
    def speed(self, task):
        global vel
        global spd
        global mvt
        global mom
        global forward
        global suspended
        global falling
        global prepos
        global pospos
        global slam
        global splat
        global mag
        global ascript
        global aslist
        global sct1
        global sct2
        global celerity
        global impact
        global frict
        global rpos
        global rneg
        global soar
        global bounce
        global run

        if run:
# want to paste all the fr physhics here later, and orginize them into "slots"
# that will keep on running and spitting out a result for a fr object to get
# if progrmed, this also inlcudes the fr's slide mechanics too.
# - speed regulators -        
            if vel[0] is 0 and spd[0] is 0:
                celerity[0] = True
                vel[0] = 0
                spd[0] = 0
            else:
                if rneg[0] <= vel[0] <= rpos[0]:
                    vel[0] = 0
                    if not rneg[0] <= spd[0] <= rpos[0]:
                       celerity[0] = False
                else:
                    if vel[0] < 0:
                       vel[0] += 0.1
                    else:
                       vel[0] += -0.1           
                if rneg[0] <= spd[0] <= rpos[0]:
                    spd[0] = 0
                    if not rneg[0] <= vel[0] <= rpos[0]:                
                       celerity[0] = True
                else:
                    if spd[0] < 0:
                       spd[0] += 0.1
                    else:
                       spd[0] += -0.1

            if celerity[0]:
                mvt[0] = int(vel[0])
            else:
                mvt[0] = int(spd[0])            
                                
# - speed limiters -
            if vel[0] < -6.0:
               vel[0] += 0.3
               if vel[0] < -6.5:
                  mag[0] = 0
                  if vel[0] < -8.0:
                     vel[0] = -8.0
            else:
               mag[0] = -5  

            if spd[0] < -6.0:
               spd[0] += 0.3
               if spd[0] < -6.5:
                  mag[0] = 0
                  if spd[0] < -15.0:
                     spd[0] = -15.0
            else:
               mag[0] = -5
           
# - gravity handler -
            if not suspended and not bounce[0]:
                dt = globalClock.getDt()
                skim = int(mom[0]) + int(mag[0])            
                pace = skim + 1
                rate = skim - 1
                if frict[0] or soar:
                     if frict[0]:
                         self.pactor.setZ(self.pactor, -5 * dt)
                     if soar:                    
                         if self.keyMap["ishop"]:
                             if self.keyMap["south"]:
                                mom[0] += 0.2
                                self.pactor.setZ(self.pactor, skim * dt)                             
                                if mom[0] > 7:
                                   mom[0] += -0.2                               
                             if self.keyMap["north"]:
                                mom[0] +=  -0.2
                                self.pactor.setZ(self.pactor, skim * dt) 
                                if mom[0] < -7:
                                   mom[0] += 0.2                               
                             if not self.keyMap["north"] and not self.keyMap["south"]:
                                if mom[0] > 0:
                                    mom[0] += -0.2
                                else:
                                    mom[0] +=  0.2 
                         else:    
                            mom[0] += -0.1
                            self.pactor.setZ(self.pactor, skim * dt)                        
                            if mom[0] < -8:
                               mom[0] += 0.1                         
                               soar = False
                else:
                    if pospos[0] <= self.pactor.getZ() <= prepos[0]: 
                         falling = True
                         prepos[0] = self.pactor.getZ() + (pace * dt)
                         pospos[0] = self.pactor.getZ() + (rate * dt)
                         self.pactor.setZ(self.pactor, skim * dt)
                         mom[0] +=  -0.2                         
                         if mom[0] < -7:
                             slam = True
                             if mom[0] < -11:
                                mom[0] += 0.2
                                splat = True
                                
                    else:
                         falling = False
                         prepos[0] = self.pactor.getZ() + (pace * dt)
                         pospos[0] = self.pactor.getZ() + (rate * dt)
                         self.pactor.setZ(self.pactor, skim * dt)               
                         if mom[0] > 0:
                            mom[0] += -0.2
                         else:
                            mom[0] +=  0.2                          
                            if slam:
                                if not splat:
                                    aslist = 2
                                    ascript = True
                                    sct1 = True
                                    slam = False
                                else:
                                    slam = False
                                    splat = False
                                    aslist = 2
                                    ascript = True
                                    sct2 = True

        return Task.cont
        
    def move(self, task):
        dt = globalClock.getDt()
        global jmpdel
        global facing
        global notdir
        global vel
        global spd
        global mvt
        global mom
        global jmpstm
        global polejmp
        global pjmp
        global letgo
        global falling
        global forward
        global shinny
        global swimming
        global soar
        global suspended
        global interacting
        global CamPar
        global look
        global norpar
        global nwpar
        global wespar
        global swpar
        global soupar
        global separ
        global easpar
        global nepar
        global leap
        global dive
        global brake
        global climbing
        global swervew
        global swervee
        global lock
        global surZ
        global surfP
        global surfY
        global sld
        global celerity                             
        global slipping
        global sliding
        global bump
        global grab
        global inactitm
        global camscn
        global camseq
        global charcrp
        global actcrp
        global creeping
        global blue
        global crpdel
        global camlock
        global camset
        global chuck
        global run

        if run:
            if blue:
                charcrp[0] = 1           
# Camera Controls (for move) - - -     
# self.obejct within self.set object is the self.get for itself.
# standard roaming mode, as normal, tilted as zoomout
            if not camscn:
                if not camlock:
                    camset = False
                    if self.keyMap["cambob"]:            
                         self.camera.setX(self.camera, -20 * dt)
                    if self.keyMap["camweave"]:
                         self.camera.setX(self.camera, +20 * dt)
                else:
                    if not camset:
                       self.pactor.setH(self.camera.getH() - 180.0)
                       camset = True
                    
                if not swimming or soar:               
                    if self.keyMap["zoomin"]:
                        if self.camera.getZ() > (self.pactor.getZ() + 2):
                          self.camera.setZ(self.camera, -0.2)
                          
                    if self.keyMap["zoomout"]:
                        if self.camera.getZ() < (self.pactor.getZ() + 16):
                          self.camera.setZ(self.camera, +0.2)   
           

# camvec is player's postion minus the camera's position or essentally the
# diffrence of the player's postion plus settting Z to 0, meaning only the
# X and Y diffrences or horizonal and verticals.
            camvec = self.pactor.getPos() - self.camera.getPos()
            camvec.setZ(0)
# camdist is the diaginal length between camvec's X and Y postions as a the
# missing trinagle piece, basiclly the distance of your character and the
# camera, the higher this number, the farther your character is away from
# the camrea, and the lower the closer.
            camdist = camvec.length()
# normalizes camvec's vector? (true if nomralize, false if zero-lentgh vector)       
            camvec.normalize()
            if not camscn:           
                if swimming or soar:
                    self.camtarget.setZ(1.0)
                    if camdist > 11.0:
                         self.camera.setPos(self.camera.getPos() + camvec * (camdist -11))
                         camdist = 11.0
                    if camdist < 10.0:
                         self.camera.setPos(self.camera.getPos() - camvec * (10 - camdist))
                         camdist = 10.0

                    self.camera.setZ(self.pactor.getZ() + CamPar)
                else:
                   if look and not lock:
                        self.camtarget.setZ(2.0)
                        if camdist > 5.1:
                            self.camera.setPos(self.camera.getPos() + camvec * (camdist -5))
                            camdist = 5.1
                        if camdist < 5.0:
                            self.camera.setPos(self.camera.getPos() - camvec * (5 - camdist))
                            camdist = 5.0                                                      
                   else:
                        self.camtarget.setZ(2.0)
                        if self.camera.getZ() < (self.pactor.getZ() + 16):
                             self.camera.setZ(self.camera, +0.2)
                        if self.camera.getZ() > (self.pactor.getZ() + 2):
                             self.camera.setZ(self.camera, -0.2)     
                             
                        if camdist > 10.0:
                             self.camera.setPos(self.camera.getPos() + camvec * (camdist -10))
                             camdist = 10.0
                        if camdist < 5.0:
                             self.camera.setPos(self.camera.getPos() - camvec * (5 - camdist))
                             camdist = 5.0

                        if self.camera.getZ() < self.pactor.getZ() + 2.0:
                            self.camera.setZ(self.pactor.getZ() + 2.0)
            else:                       
                   self.camera.setX(camseq[0])
                   self.camera.setY(camseq[1])
                   self.camera.setZ(camseq[2])
                   
            self.camera.lookAt(self.camtarget)
            norpar = self.camera.getH() - 180.0
            nwpar = self.camera.getH() - 135.0
            wespar = self.camera.getH() - 90.0
            swpar = self.camera.getH() - 45.0
            soupar = self.camera.getH()
            separ = self.camera.getH() + 45.0
            easpar = self.camera.getH() + 90.0
            nepar = self.camera.getH() + 135.0
# 180 the normal for camera getH.

# Player Controls (for move) - - -
# this makes the player jump, by declaring the state of jumping as true and
# increasing the Z co-ord, when let go, the fall (gravity) function will kick
# in causing the player to fall back into place.
            if look:
                suspended = False
                actcrp = 0
                if not lock:            
                    if self.keyMap["north"]:               
                          if self.camera.getZ() > self.pactor.getZ():
                             self.camera.setZ(self.camera, -0.2)                    
                    if self.keyMap["west"]:
                         self.camera.setX(self.camera, -20 * dt)              
                    if self.keyMap["south"]:
                          if self.camera.getZ() < (self.pactor.getZ() + 16):
                             self.camera.setZ(self.camera, +0.2)                 
                    if self.keyMap["east"]:
                         self.camera.setX(self.camera, +20 * dt)
                    if not interacting:
                        if self.keyMap["zoomout"]:
                            self.camera.setZ(2)
                            look = False
                            
            else:    
                if not swimming and not shinny and not slipping and not soar:
                       suspended = False
                       if self.keyMap["ishop"]:
                              if grab:
                                  actcrp = 1
                                  if forward:
                                      chuck = True
                                      grab = False                                      
                                  else:
                                      chuck = False
                                      grab = False
                              else:    
                                  if not falling and not jmpstm:
                                     actcrp = 2 
                                     jmpstm = True    
                                     mom[0] += 11.0
                                     leap = True
                                  else:          
                                     jmpdel += 1
                                     if jmpdel is 30:
                                        leap = False
                                        jmpstm = False
                                        jmpdel = 0
                       else:
                           if not grab:
                                  jmpdel += 1
                                  if jmpdel is 30:
                                     leap = False
                                     jmpstm = False
                                     jmpdel = 0

                       if self.keyMap["creep"]:
                           if creeping:
                               if not crpdel > 10:
                                  crpdel += 1
                               else:
                                  crpdel = 0 
                                  creeping = False
                           else:
                               if not crpdel > 10:
                                  crpdel += 1
                               else:
                                  crpdel = 0 
                                  creeping = True
# when a player presses a buttion, the driection of that buttion becomes true
# as long as the press happens, a press results in the player's speed and
# movement going foward.

                       if self.keyMap["north"] or self.keyMap["east"] or self.keyMap["south"] or self.keyMap["west"]:
                           if not creeping:
                               forward = True
                               actcrp = 3
                               self.pactor.setY(self.pactor, mvt[0] * dt)
                           else:
                               forward = True
                               actcrp = 0
                               mvt[0] = mvt[0] / 2
                               self.pactor.setY(self.pactor, mvt[0] * dt)                           

                           if self.keyMap["north"]:
                              if self.camera.getH() - 45.0 <= facing <= self.camera.getH() + 45.0:
                                 brake = True                                 
                                 vel[0] = 0
                                 spd[0] = 0                             
                              if self.keyMap["east"] or self.keyMap["west"]:
                                    vel[0] += -0.2
                                    spd[0] += -0.2
                                    if self.keyMap["east"]:
                                        facing = nepar
                                        self.pactor.setH(facing)
                                    if self.keyMap["west"]:
                                        facing = nwpar
                                        self.pactor.setH(facing)
                              else:
                                        vel[0] += -0.2
                                        spd[0] += -0.2
                                        facing = norpar
                                        self.pactor.setH(facing)                             

                           elif self.keyMap["west"]:
                              if self.camera.getH() + 45.0 <= facing <= self.camera.getH() + 135.0:  
                                 brake = True                                 
                                 vel[0] = 0
                                 spd[0] = 0                             
                              if self.keyMap["north"] or self.keyMap["south"]:
                                    vel[0] += -0.2
                                    spd[0] += -0.2                                 
                                    if self.keyMap["north"]:
                                        facing = nwpar
                                        self.pactor.setH(facing)

                                    if self.keyMap["south"]:
                                        facing = swpar
                                        self.pactor.setH(facing)
                              else:
                                        vel[0] += -0.2
                                        spd[0] += -0.2
                                        facing = wespar
                                        self.pactor.setH(facing)

                           elif self.keyMap["south"]:                       
                              if not self.camera.getH() - 135.0 <= facing <= self.camera.getH() + 135.0:
                                 brake = True                                 
                                 vel[0] = 0
                                 spd[0] = 0                             
                              if self.keyMap["east"] or self.keyMap["west"]:
                                      vel[0] += -0.2
                                      spd[0] += -0.2                              
                                      if self.keyMap["east"]:
                                        facing = separ
                                        self.pactor.setH(facing)
                                      if self.keyMap["west"]:
                                        facing = swpar
                                        self.pactor.setH(facing)
                              else:
                                        vel[0] += -0.2
                                        spd[0] += -0.2
                                        facing = soupar
                                        self.pactor.setH(facing)
                                                                  
                           elif self.keyMap["east"]:
                              if self.camera.getH() - 135.0 <= facing <= self.camera.getH() - 45.0:  
                                 brake = True                                 
                                 vel[0] = 0
                                 spd[0] = 0 
                              if self.keyMap["north"] or self.keyMap["south"]:
                                      vel[0] += -0.2
                                      spd[0] += -0.2
                                      if self.keyMap["north"]:
                                        facing = nepar
                                        self.pactor.setH(facing)
                                      if self.keyMap["south"]:
                                        facing = separ
                                        self.pactor.setH(facing)
                              else:
                                        vel[0] += -0.2
                                        spd[0] += -0.2
                                        facing = easpar
                                        self.pactor.setH(facing)
                      
                       else:
                           forward = False
    #                       self.pactor.setY(self.pactor, mvt * dt)

# when positive actor normal is collided, you are projected forward, when a
# negative actor normal is collided, you are projected backwards
# the sliding controls, this below is the "slding mode" below
                if not celerity[0]:
                   if not swimming or shinny or soar:
                           slipping = True
                           actcrp = 5
                           self.pactor.setY(self.pactor, sld[0] * dt)
                           if not -0.5 <= surfY[0] <= 0.5: 
                               if surfY[0] > 0:
                                   sld[0] = spd[0] * -1
                               else:
                                   sld[0] = spd[0] * 1

                           if not surZ[0] > 7.7: 
                               self.pactor.lookAt(surfP[0])
                                                        
                           if not surZ[0] > 5.0 and not bump:
                              sliding = True
                           else:
                              sliding = False
        
                           if self.keyMap["west"]:
                              self.pactor.setX(self.pactor, +3 * dt)

                           if self.keyMap["east"]:
                              self.pactor.setX(self.pactor, -3 * dt)                             

                           if self.keyMap["north"]:
                              spd[0] += -0.2

                           if self.keyMap["south"]:
                              spd[0] += 0.2

                           if self.keyMap["ishop"]:
                              if not falling and not jmpstm:                           
                                 jmpstm = True    
                                 mom[0] += 11.0
                                 leap = True
                              else:          
                                 jmpdel += 1
                                 if jmpdel is 30:
                                    leap = False
                                    jmpstm = False
                                    jmpdel = 0
                           else:
                              jmpdel += 1
                              if jmpdel is 30:
                                 leap = False
                                 jmpstm = False
                                 jmpdel = 0
                                  
                else:
                       slipping = False
                       sliding = False
                   
# the shinny controls.
                if shinny:
                    if not swimming or soar:
                       suspended = True
                       leap = False
                       falling = False
                       actcrp = 2
                       if self.keyMap["ishop"]:
                             if not pjmp < 0:
                                pjmp -= 1
                             else:
                                pjmp = 30 
                                climbing = False
                                shinny = False
                                self.pactor.setY(self.pactor, 0.5)
                                mom[0] += 2.0
                                leap = True
                       else:
                             if not pjmp < 0:
                                pjmp -= 1
                             else:
                                pjmp = 30
                                

                       if self.keyMap["north"] or self.keyMap["east"] or self.keyMap["south"] or self.keyMap["west"]:
                           leap = False
                           climbing = True

                           if self.keyMap["north"]:
                              if letgo:
                                self.pactor.setZ(self.pactor, +2.0)
                                shinny = False
                              else:
                                self.pactor.setZ(self.pactor, 1 * dt)
                                
                           if self.keyMap["west"]:
                              self.pactor.setH(self.pactor.getH() - 80 * dt)
                              self.pactor.setX(self.pactor, 0.5 * dt)
                                
                           if self.keyMap["south"]:
                              if land:
                                self.pactor.setY(self.pactor, +1 * dt)
                                shinny = False
                              else:
                                if letgo:
                                   self.pactor.setZ(self.pactor, -1.0)
                                   shinny = False
                                else:                          
                                   self.pactor.setZ(self.pactor, -1 * dt)
                                
                           if self.keyMap["east"]:
                              self.pactor.setH(self.pactor.getH() + 80 * dt)
                              self.pactor.setX(self.pactor, -0.5 * dt)

                       else:
                           climbing = False
                           leap = False
                    else:
                        swimming = False
                        soar = False
# the swimming/soaring controls.               
                if swimming or soar:
                    if not shinny:
                       actcrp = 1                    
                       if soar:
                           suspended = False
                           if swimming:
                               soar = False
                       if swimming:
                           suspended = True
                           
                       if self.keyMap["ishop"]:
                           if dive is 0:
                              dive = 1
                           else:   
                              dive = 2
                           self.pactor.setY(self.pactor, -8 * dt)
                           camlock = True
                              
                           if self.keyMap["north"]:
                              if self.pactor.getP() < 35.0:
                                 self.pactor.setP(self.pactor.getP() + 180 * dt)
                                 if CamPar < 15.0:
                                     CamPar += 0.1
                              else:
                                 if CamPar < 15.0:
                                     CamPar += 0.1
                           else:
                                 if not self.pactor.getP() is 0.0:
                                    if self.pactor.getP() > 0.0:
                                         self.pactor.setP(self.pactor.getP() - 180 * dt)
                                         if CamPar > 2.0:
                                             CamPar -= 0.2
                                    else:
                                         if CamPar > 2.0:
                                             CamPar -= 0.2
                                 else:
                                    if CamPar > 2.0:
                                        CamPar -= 0.2
                                             
                           if self.keyMap["west"]:
                              swervew = True 
                              self.pactor.setH(self.pactor.getH() + 80 * dt)
                           else:
                              swervew = False
                           if self.keyMap["south"]:
                              if self.pactor.getP() > -35.0:                       
                                 self.pactor.setP(self.pactor.getP() - 180 * dt)
                                 if CamPar > -6.0:
                                     CamPar -= 0.1
                              else:
                                 if CamPar > -6.0:
                                     CamPar -= 0.1
                           else:
                                 if not self.pactor.getP() is 0.0:
                                    if self.pactor.getP() < 0.0:
                                         self.pactor.setP(self.pactor.getP() + 180 * dt)
                                         if CamPar < 2.0:
                                             CamPar += 0.2
                                    else:
                                         if CamPar < 2.0:
                                             CamPar += 0.2
                                 else:
                                    if CamPar < 2.0:
                                        CamPar += 0.2                                 
                           if self.keyMap["east"]:
                              swervee = True 
                              self.pactor.setH(self.pactor.getH() - 80 * dt)
                           else:
                              swervee = False                          
                       else:
                            if dive is 2:
                              dive = 3
                            else:   
                              dive = 0
                            camlock = False  
                            self.pactor.setP(0.0)
                            self.pactor.setH(norpar)
                            if CamPar > 2.0:
                                 CamPar -= 0.2
                            else:
                                if CamPar < 1.8:
                                    CamPar += 0.2
                                   
                else:
                     swervee = False
                     swervew = False
                     self.pactor.setP(0.0)
                     dive = 0
                     camlock = False
                 
        return Task.cont
       
    def interact(self, task):
        global interact
        global inactset
        global inactobj
        global inactitm
        global grab
        global iactline
        global textdel
        global interacting
        global iaforward
        global iaup
        global iactend
        global look
        global curline
        global tspd
        global dumcom
        global iactline0
        global iactline1
        global iactline2
        global iactline3
        global iactline4
        global iactline5
        global iactline6
        global iactline7
        global iactline8
        global iactline9
        global pick
        global np
        global run
        if run:
            if interact or interacting:            
                if interacting:                  
                    if iactline is iactend:
                        iactend = 0
                        iactline = 0
                        textdel = 0
                        inactset = False
                        inactobj = False
                        interacting = False
                        interact = False
                        look = False
                    else:
                      if iactline is 10:
                        iactline = 0
                        textdel = 0
                        iactend = 0
                        inactset = False
                        inactobj = False
                        interact = False
                        interacting = False
                        look = False
                      else:  
                        curline = "iactline" + str(iactline)
                        self.interactline.setText(eval(curline))
                        textdel += 1
                        if textdel > 60:
                           textdel -= 1                       
                           if not look:
                              textdel = tspd 
                              iactline += 1
                           else:
                              if self.keyMap["ishop"]:
                                 textdel = 0
                                 iactline += 1
                else:
                    if not inactset:                   
                        if inactobj:
                           self.interactline.setText("Check")
                           inactset = True
                        elif inactitm:
                           self.interactline.setText("Grab")
                           inactset = True                       
                        else:
                           self.interactline.setText("Speak")
                           inactset = True
                    else:
                        if not inactitm:
                            if self.keyMap["ishop"]:
                                 look = True
                                 self.pobject.lookAt(iaforward + iaup)
                                 self.pactor.setY(self.pactor, +1.0)
                                 interacting = True
                        else:                        
                            if self.keyMap["ishop"]:
                                 np = pick
                                 np.wrtReparentTo(self.pequip)
                                 grab = True
                                                                                    
            else:
                self.interactline.setText(":")
                inactitm = False
                interact = False
                inactset = False

        return Task.cont          

    def leaveinact(self, entry):
           global interact
           global run
           if run:
               interact = False          

    def noise(self, task):
        global crp
        global surcrp
        global charcrp
        global actcrp
        global nse
        global noise
        global frlst
        global din
        global nse
        global run
        if run:
            crp[0] = surcrp + charcrp[0] + actcrp
            nse = crp.index(max(crp))         
            din = crp[nse]
            if nse is 0:                      
               noise = self.pactor.getPos()
            else:
               noise = frlst[nse].getPos()
             
        return Task.cont

    def rng(self, task):
        global seed
        global rng
        global run
        if run:
            ft = globalClock.getFrameTime()      
            seed[0] = abs(self.pactor.getX())
            seed[1] = abs(self.pactor.getY())
            seed[2] = abs(self.pactor.getZ())
            root = seed.index(max(seed))
            cultv = seed[root] * ft
            cseq = cultv * cultv
            ln = abs(cseq) % 10
            rng = int(ln)

        return Task.cont
    
# - Debugging Functions -
# The actual text functions for the debug list.
    def debugupdate(self, task):
        global vel
        global mom
        global spd
        global HP
        line1 = "- DEBUG DISPLAY-"
        line2 = "VELOCITY" + str(vel[0]) 
        line3 = "MOMENTUM:" + str(mom[0]) 
        line4 = "SPEED:" + str(spd[0])
        line5 = "PLAYERS HP:" + str(HP[0])
        line6 = "PANDA3D VER." + str(PandaSystem.getVersionString())

# these set the text into each of the created nodes listed after "self". 
        self.debugline1.setText(line1)
        self.debugline2.setText(line2)
        self.debugline3.setText(line3)
        self.debugline4.setText(line4)
        self.debugline5.setText(line5)
        self.debugline6.setText(line6) 
        
        return Task.cont
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# ******************************[Dummy Level]**********************************
# Theme ***
    def theme(self, task):
        global thmset
        global thmready
        if thmset:
# this determines the game's lighting based on the theme.            
            ambientLight = AmbientLight("ambientLight")
            ambientLight.setColor((.3, .3, .3, 1))
            directionalLight = DirectionalLight("directionalLIght")
            directionalLight.setDirection((-5, -5, -5))
            directionalLight.setColor((1, 1, 1, 1))
            directionalLight.setSpecularColor((1, 1, 1, 1))
            render.setLight(render.attachNewNode(ambientLight))
            render.setLight(render.attachNewNode(directionalLight))
# this determines the game's background image based on the theme.
            background = loader.loadModel("room/bgbox.egg")
            background.setBin('background', 1)
            background.setDepthWrite(0)            
            background.reparentTo(self.camera)
            background.setShaderOff()
            background.setLightOff()
            background.setPos(0, 1.8, -1)
            background.setTwoSided(True)
            bgtexture = loader.loadTexture("room/tex/bgtextest.png")
            background.setTexture(bgtexture, 1)
# this is a collision loader list for static items on the scene.
            self.scnev1 = NodePath(CollisionNode("scnev1"))
            self.scnev1.reparentTo(self.render)
            self.sev1pos = self.scene.find("**/sign").getPos()           
            self.scnev1.setPos(self.sev1pos + (-10, 0, 0))
            self.scnc1 = CollisionSphere(0, 0, 0.0, 1.8)
            self.scnc1.setTangible(0)
            self.scnev1.node().addSolid(self.scnc1)             
            base.cTrav.addCollider(self.scnev1, self.pusher)            
            thmset = False                   
            
        return Task.cont 

# Boundaries ***
    def camrtn(self, entry):
        global camscn
        global run
        if run:
            camscn = False       
        
    def camscn01(self, entry):
        global camscn
        global camseq
        global run
        if run:
            camseq[0] = self.scene.find("**/camscn1b").getX()        
            camseq[1] = self.scene.find("**/camscn1b").getY()
            camseq[2] = self.scene.find("**/camscn1b").getZ() + 4.0
            camscn = True
            
#    def outbound(self, task):
#        if self.pactor.getZ() < dwnzbound or self.pactor.getZ() > upzbound:
#            self.pactor.setPos(0.0, 0.0, 6.3)

#        if self.pactor.getY() < souybound or self.pactor.getY() > norybound:
#            self.pactor.setPos(0.0, 0.0, 6.3)

#        if pactor.getX() < easxbound or self.pactor.getX() > wesxbound:
#            pactor.setPos(0.0, 0.0, 6.3)        

# From Objects ***
    def fr01(self, task):
        global switch
        global grab
        global np
        global vel
        global spd
        global celerity
        global rneg
        global rpos
        global mvt
        global mag
        global sld
        global surfY
        global surZ
        global surfP
        global frict
        global surf
        global relp
        global frlst
        global slddel
        global charcrp
        global tap
        global chuck
        global fling
        global flingdel
        global run
        if run:
# - Loading Handler -            
            if not switch[1] > 0:               
                frlst[1] = Actor("actor/itmbox.egg")
                frlst[1].reparentTo(self.render) 
                self.oact1pos = self.scene.find("**/col05").getPos()
                frlst[1].setPos(self.oact1pos)
                frlst[1].setZ(1.0)
                self.oactor1cn = frlst[1].attachNewNode(CollisionNode('fr1'))
                self.oactor1cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
                self.selradius1 = CollisionSphere(0, 0, 0.0, 1.0)
                self.selradius1.setTangible(0)
                self.oactor1cn.node().addSolid(self.selradius1)             
                self.pusher.addCollider(self.oactor1cn, frlst[1])
                base.cTrav.addCollider(self.oactor1cn, self.pusher)
                self.atttar1 = NodePath(CollisionNode("atttar1"))
                self.atttar1.reparentTo(self.render)
                self.atttar1.setPos(0, 0, 0)
                self.attradius1 = CollisionSphere(0, 0, 0.2, 0.1)
                self.attradius1.setTangible(0)
                self.atttar1.node().addSolid(self.attradius1)                                  
                charcrp[1] = 0
                switch[1] = 1
            else:
                if not switch[1] > 1:               
                   dt = globalClock.getDt()
# - Surface Handler -
                   if frict[1]:
                        frlst[1].headsUp(relp[1], surf[1])
                   else:
                        if surZ[1] > 7.7:               
                            frlst[1].headsUp(relp[1], surf[1])
                            slp = 0
                            rneg[1] = -0.1
                            rpos[1] = 0.1                    
                        else:
                            slddel[1] += 1
                            rneg[1] = -0.4
                            rpos[1] = 0.4                    
                            if slddel[1] > 3:
                                slddel[1] = 0
                                slp = surZ[1] - 7.0
                                spd[1] += abs(slp) * -1
                                vel[1] += abs(slp) * 1
                                if vel[1] > 0:
                                    vel[1] = 0   
                   
# - Speed Handler (Regualator) -                    
                   if vel[1] is 0 and spd[1] is 0:
                        celerity[1] = True
                        vel[1] = 0
                        spd[1] = 0
                   else:
                        if rneg[1] <= vel[1] <= rpos[1]:
                            vel[1] = 0
                            if not rneg[1] <= spd[1] <= rpos[1]:
                               celerity[1] = False
                        else:
                            if vel[1] < 0:
                               vel[1] += 0.1
                            else:
                               vel[1] += -0.1           
                        if rneg[1] <= spd[1] <= rpos[1]:
                            spd[1] = 0
                            if not rneg[1] <= vel[1] <= rpos[1]:                
                               celerity[1] = True
                        else:
                            if spd[1] < 0:
                               spd[1] += 0.1
                            else:
                               spd[1] += -0.1

                   if celerity[1]:
                        mvt[1] = int(vel[1])
                   else:
                        mvt[1] = int(spd[1])            
                                            
# - Speed Handler (Limiter) -
                   if vel[1] < -6.0:
                       vel[1] += 0.3
                       if vel[1] < -6.5:
                          mag[1] = 0
                          if vel[1] < -8.0:
                             vel[1] = -8.0
                   else:
                       mag[1] = -5  

                   if spd[1] < -6.0:
                       spd[1] += 0.3
                       if spd[1] < -6.5:
                          mag[1] = 0
                          if spd[1] < -15.0:
                             spd[1] = -15.0
                   else:
                       mag[1] = -5

# - Speed Handler (Slider) -
                   if not celerity[1]:
                           frlst[1].setY(frlst[1], sld[1] * dt)
                           if not -0.5 <= surfY[1] <= 0.5: 
                               if surfY[1] > 0:
                                   sld[1] = spd[1] * -1
                               else:
                                   sld[1] = spd[1] * 1

                           if not surZ[1] > 7.7: 
                               frlst[1].lookAt(surfP[1])                     
                   
# - Gravity Handler -
                   if not fling:
                       skim = int(mom[1]) + int(mag[1])            
                       pace = skim + 1
                       rate = skim - 1
                       if pospos[1] <= frlst[1].getZ() <= prepos[1]:
                             prepos[1] = frlst[1].getZ() + (pace * dt)
                             pospos[1] = frlst[1].getZ() + (rate * dt)
                             frlst[1].setZ(frlst[1], skim * dt)
                             mom[1] += -0.2
                             if mom[1] < -7:
                                 if mom[1] < -11:
                                    mom[1] += 0.2
                                    
                       else:
                             prepos[1] = frlst[1].getZ() + (pace * dt)
                             pospos[1] = frlst[1].getZ() + (rate * dt)
                             frlst[1].setZ(frlst[1], skim * dt)               
                             if mom[1] > 0:
                                mom[1] += -0.2
                             else:
                                mom[1] +=  0.2

# - Noise Regulator -
                   if tap[1] > -1:
                       if tap[1] is 0:
                          crp[1] = abs(mom[1])
                       else:
                          crp[1] = abs(mom[1]) * abs(tap[1])                       
                   else:
                       crp[1] = abs(mom[1]) / abs(tap[1])

# - Fling State -
                   if fling:
                      vel[1] += -0.2
                      spd[1] += -0.2
                      aipce = mvt[1] * 2
                      frlst[1].lookAt(self.pactor)                         
                      frlst[1].setY(frlst[1], -3 * dt)
                      frlst[1].setZ(frlst[1], +3 * dt)
                      flingdel += 1
                      if flingdel > 40:
                          flingdel = 0
                          fling = False
                            
# - Held State -                                 
                   if grab and np is frlst[1]: 
                        self.oactor1cn.stash()
                        switch[1] = 2
# - Release State -                        
                else:
                   if not grab:
                        frlst[1].reparentTo(self.render)
                        self.oactor1cn.unstash()
                        frlst[1].setPos(0, -1, 0)
                        if chuck:                       
                            frlst[1].setPos(self.pactor.getPos())                        
                            self.atttar1.setPos(self.pactor.getPos() + (0, -1, 0))
                            self.atttar1.wrtReparentTo(self.render)
                            frlst[1].setScale(1)                        
                            fling = True                        
                            switch[1] = 1
                        else:
                            frlst[1].setPos(self.pactor.getPos()) 
                            frlst[1].setHpr(0, 0, 0)
                            frlst[1].setY(self.pactor, -1)                       
                            frlst[1].setScale(1)
                            switch[1] = 1                        
                        
        return Task.cont

    def fr02(self, task):
        global switch
        global grab
        global np
        global vel
        global spd
        global celerity
        global rneg
        global rpos
        global mvt
        global mag
        global sld
        global surfY
        global surZ
        global surfP
        global frict
        global surf
        global relp
        global frlst
        global slddel
        global crp
        global din
        global debug
        global charcrp
        global chase
        global suspect
        global suspected
        global suspos
        global delay
        global noise
        global attend
        global appro
        global seen
        global see
        global bounce
        global run
# - Loading Handler -
        if run:
            if not switch[2] > 0:               
                frlst[2] = Actor("actor/opptest.egg", {"Walk": "actor/opptest-ani/opptest-Walk"})
                frlst[2].reparentTo(self.render) 
                self.oact2pos = self.scene.find("**/en01").getPos()
                frlst[2].setPos(self.oact2pos)
                frlst[2].setZ(frlst[2], +1.0)            
                self.oactor2cn = frlst[2].attachNewNode(CollisionNode('fr2'))            
                self.oactor2cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
                self.pusher.addCollider(self.oactor2cn, frlst[2])
                base.cTrav.addCollider(self.oactor2cn, self.pusher)            
                self.actvis2cn = frlst[2].attachNewNode(CollisionNode('vi2'))             
                self.actvis2 = CollisionTube(0, 0, 0.2, 0, -6.0, 0.2, 0.2)           
                self.actvis2.setTangible(0)           
                self.actvis2cn.node().addSolid(self.actvis2)
                self.selradius2 = CollisionSphere(0, 0, 0.0, 2.0)
                self.selradius2.setTangible(0)
                self.actvis2cn.node().addSolid(self.selradius2)            
                self.pusher.addCollider(self.actvis2cn, frlst[2])
                base.cTrav.addCollider(self.actvis2cn, self.pusher)           
                frlst[2].loop("Walk")
                self.atttar2 = NodePath(CollisionNode("atttar2"))
                self.atttar2.reparentTo(self.render)
                self.atttar2.setPos(0, 0, 0)
                self.attradius2 = CollisionSphere(0, 0, 0.2, 0.1)
                self.attradius2.setTangible(0)
                self.atttar2.node().addSolid(self.attradius2)                       
                charcrp[2] = -2
                switch[2] = 1
                if debug:
                    self.oactor2cn.show()
            else:
                if not switch[2] > 1:               
                   dt = globalClock.getDt()
# - Surface Handler -
                   if frict[2]:
                        frlst[2].headsUp(relp[2], surf[2])
                   else:
                        if surZ[2] > 7.7:               
                            frlst[2].headsUp(relp[2], surf[2])
                            slp = 0
                            rneg[2] = -0.1
                            rpos[2] = 0.1                    
                        else:
                            slddel[2] += 1
                            rneg[2] = -0.4
                            rpos[2] = 0.4                    
                            if slddel[2] > 3:
                                slddel[2] = 0
                                slp = surZ[2] - 7.0
                                spd[2] += abs(slp) * -1
                                vel[2] += abs(slp) * 1
                                if vel[2] > 0:
                                    vel[2] = 0   
               
# - Speed Handler (Regualator) -                    
                   if vel[2] is 0 and spd[2] is 0:
                        celerity[2] = True
                        vel[2] = 0
                        spd[2] = 0
                   else:
                        if rneg[2] <= vel[2] <= rpos[2]:
                            vel[2] = 0
                            if not rneg[2] <= spd[2] <= rpos[2]:
                               celerity[2] = False
                        else:
                            if vel[2] < 0:
                               vel[2] += 0.1
                            else:
                               vel[2] += -0.1           
                        if rneg[2] <= spd[2] <= rpos[2]:
                            spd[2] = 0
                            if not rneg[2] <= vel[2] <= rpos[2]:                
                               celerity[2] = True
                        else:
                            if spd[2] < 0:
                               spd[2] += 0.1
                            else:
                               spd[2] += -0.1

                   if celerity[2]:
                        mvt[2] = int(vel[2])
                   else:
                        mvt[2] = int(spd[2])          
                                        
# - Speed Handler (Limiter) -
                   if vel[2] < -6.0:
                       vel[2] += 0.3
                       if vel[2] < -6.5:
                          mag[2] = 0
                          if vel[2] < -8.0:
                             vel[2] = -8.0
                   else:
                       mag[2] = -5  

                   if spd[2] < -6.0:
                       spd[2] += 0.3
                       if spd[2] < -6.5:
                          mag[2] = 0
                          if spd[2] < -15.0:
                             spd[2] = -15.0
                   else:
                       mag[2] = -5

# - Speed Handler (Slider) -
                   if not celerity[2]:
                           frlst[2].setY(frlst[2], sld[2] * dt)
                           if not -0.5 <= surfY[2] <= 0.5: 
                               if surfY[2] > 0:
                                   sld[2] = spd[2] * -1
                               else:
                                   sld[2] = spd[2] * 1

                           if not surZ[2] > 7.7: 
                               frlst[2].lookAt(surfP[2])                     
                   
# - Gravity Handler -
                   if not bounce[2]:
                       skim = int(mom[2]) + int(mag[2])            
                       pace = skim + 1
                       rate = skim - 1
                       if pospos[2] <= frlst[2].getZ() <= prepos[2]:
                             prepos[2] = frlst[2].getZ() + (pace * dt)
                             pospos[2] = frlst[2].getZ() + (rate * dt)
                             frlst[2].setZ(frlst[2], skim * dt)
                             mom[2] += -0.2
                             if mom[2] < -7:
                                 if mom[2] < -11:
                                    mom[2] += 0.2
                                    
                       else:
                             prepos[2] = frlst[2].getZ() + (pace * dt)
                             pospos[2] = frlst[2].getZ() + (rate * dt)
                             frlst[2].setZ(frlst[2], skim * dt)               
                             if mom[2] > 0:
                                mom[2] += -0.2
                             else:
                                mom[2] +=  0.2                      

# - AI Sequence (Seek)-
                   see[2] = self.actvis2cn.node().getSolid(0)
                   if not suspect[0]:
                           if delay[1] is 0:
                               self.atttar2.setPos(noise)

                   if not suspect[0] and not attend[2] and not seen[2]:                   
                      vel[2] += -0.2
                      spd[2] += -0.2
                      aipce = mvt[2] / 4 * 1                  
                      frlst[2].setY(frlst[2], aipce * dt)
                      frlst[2].setH(frlst[2].getH() - 80 * dt)                  
                       
                   if seen[2]:
                       attend[2] = False
                       appro[2] = False
                       suspect[0] = False
                       delay[1] = 0 
                       vel[2] += -0.2
                       spd[2] += -0.2
                       aipce = mvt[2] /2 * 1 
                       frlst[2].setY(frlst[2], aipce * dt)
                       frlst[2].lookAt(self.pactor)
                       frlst[2].setH(frlst[2].getH() -180)
                       frlst[2].setP(0.0)
                       
                   if attend[2] and not suspect[0]:
                        if din > 4:
                           suspect[0] = True

                   if suspect[0] and not seen[2]:
                      vel[2] += -0.2
                      spd[2] += -0.2
                      aipce = mvt[2] / 8 * -1 
                      frlst[2].lookAt(self.atttar2)                         
                      frlst[2].setY(frlst[2], aipce * dt)
                      frlst[2].setH(frlst[2].getH() -180)
                      frlst[2].setP(0.0)                  

                   if appro[2]:
                      delay[1] += 1
                      if delay[1] > 100:
                          self.atttar2.setPos(0, 0, 0)
                          attend[2] = False
                          appro[2] = False
                          suspect[0] = False
                          delay[1] = 0                                                                         

        return Task.cont

    def fr03(self, task):
        global switch
        global grab
        global np
        global vel
        global spd
        global celerity
        global rneg
        global rpos
        global mvt
        global mag
        global sld
        global surfY
        global surZ
        global surfP
        global frict
        global surf
        global relp
        global frlst
        global slddel
        global crp
        global din
        global debug
        global charcrp
        global chase
        global suspect
        global suspected
        global suspos
        global delay
        global noise
        global attend
        global appro
        global seen
        global see
        global run
        if run:
# - Loading Handler -            
            if not switch[7] > 0:               
                frlst[7] = Actor("actor/opptest.egg", {"Walk": "actor/opptest-ani/opptest-Walk"})
                frlst[7].reparentTo(self.render) 
                self.oact7pos = self.scene.find("**/en02").getPos()
                frlst[7].setPos(self.oact7pos)
                frlst[7].setZ(frlst[7], +1.0)             
                self.oactor7cn = frlst[7].attachNewNode(CollisionNode('fr7'))            
                self.oactor7cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
                self.pusher.addCollider(self.oactor7cn, frlst[7])
                base.cTrav.addCollider(self.oactor7cn, self.pusher)            
                self.actvis7cn = frlst[7].attachNewNode(CollisionNode('vi7'))             
                self.actvis7 = CollisionTube(0, 0, 0.2, 0, -6.0, 0.2, 0.2)           
                self.actvis7.setTangible(0)           
                self.actvis7cn.node().addSolid(self.actvis7)
                self.selradius7 = CollisionSphere(0, 0, 0.0, 2.0)
                self.selradius7.setTangible(0)
                self.actvis7cn.node().addSolid(self.selradius7)            
                self.pusher.addCollider(self.actvis7cn, frlst[7])
                base.cTrav.addCollider(self.actvis7cn, self.pusher)           
                frlst[7].loop("Walk")
                self.atttar7 = NodePath(CollisionNode("atttar7"))
                self.atttar7.reparentTo(self.render)
                self.atttar7.setPos(0, 0, 0)
                self.attradius7 = CollisionSphere(0, 0, 0.2, 0.1)
                self.attradius7.setTangible(0)
                self.atttar7.node().addSolid(self.attradius7)                       
                charcrp[7] = -2
                switch[7] = 1
                if debug:
                    self.oactor7cn.show()
            else:
                if not switch[7] > 1:               
                   dt = globalClock.getDt()
# - Surface Handler -
                   if frict[7]:
                        frlst[7].headsUp(relp[7], surf[7])
                   else:
                        if surZ[7] > 7.7:               
                            frlst[7].headsUp(relp[7], surf[7])
                            slp = 0
                            rneg[7] = -0.1
                            rpos[7] = 0.1                    
                        else:
                            slddel[7] += 1
                            rneg[7] = -0.4
                            rpos[7] = 0.4                    
                            if slddel[7] > 3:
                                slddel[7] = 0
                                slp = surZ[7] - 7.0
                                spd[7] += abs(slp) * -1
                                vel[7] += abs(slp) * 1
                                if vel[7] > 0:
                                    vel[7] = 0   
               
# - Speed Handler (Regualator) -                    
                   if vel[7] is 0 and spd[7] is 0:
                        celerity[7] = True
                        vel[7] = 0
                        spd[7] = 0
                   else:
                        if rneg[7] <= vel[7] <= rpos[7]:
                            vel[7] = 0
                            if not rneg[7] <= spd[7] <= rpos[7]:
                               celerity[7] = False
                        else:
                            if vel[7] < 0:
                               vel[7] += 0.1
                            else:
                               vel[7] += -0.1           
                        if rneg[7] <= spd[7] <= rpos[7]:
                            spd[7] = 0
                            if not rneg[7] <= vel[7] <= rpos[7]:                
                               celerity[7] = True
                        else:
                            if spd[7] < 0:
                               spd[7] += 0.1
                            else:
                               spd[7] += -0.1

                   if celerity[7]:
                        mvt[7] = int(vel[7])
                   else:
                        mvt[7] = int(spd[7])          
                                        
# - Speed Handler (Limiter) -
                   if vel[7] < -6.0:
                       vel[7] += 0.3
                       if vel[7] < -6.5:
                          mag[7] = 0
                          if vel[7] < -8.0:
                             vel[7] = -8.0
                   else:
                       mag[7] = -5  

                   if spd[7] < -6.0:
                       spd[7] += 0.3
                       if spd[7] < -6.5:
                          mag[7] = 0
                          if spd[7] < -15.0:
                             spd[7] = -15.0
                   else:
                       mag[7] = -5

# - Speed Handler (Slider) -
                   if not celerity[7]:
                           frlst[7].setY(frlst[7], sld[7] * dt)
                           if not -0.5 <= surfY[7] <= 0.5: 
                               if surfY[7] > 0:
                                   sld[7] = spd[7] * -1
                               else:
                                   sld[7] = spd[7] * 1

                           if not surZ[7] > 7.7: 
                               frlst[7].lookAt(surfP[7])                     
                   
# - Gravity Handler -
                   skim = int(mom[7]) + int(mag[7])            
                   pace = skim + 1
                   rate = skim - 1
                   if pospos[7] <= frlst[7].getZ() <= prepos[7]:
                         prepos[7] = frlst[7].getZ() + (pace * dt)
                         pospos[7] = frlst[7].getZ() + (rate * dt)
                         frlst[7].setZ(frlst[7], skim * dt)
                         mom[7] += -0.2
                         if mom[7] < -7:
                             if mom[7] < -11:
                                mom[7] += 0.2
                                
                   else:
                         prepos[7] = frlst[7].getZ() + (pace * dt)
                         pospos[7] = frlst[7].getZ() + (rate * dt)
                         frlst[7].setZ(frlst[7], skim * dt)               
                         if mom[7] > 0:
                            mom[7] += -0.2
                         else:
                            mom[7] +=  0.2                      

# - AI Sequence (Flee)-
                   see[7] = self.actvis7cn.node().getSolid(0)
                   if not suspect[1]:
                           if delay[2] is 0:
                               self.atttar7.setPos(noise)

                   if not suspect[1] and not attend[7] and not seen[7]:                   
                      frlst[7].setH(frlst[7].getH() - 80 * dt)                  
                       
                   if seen[7]:
                       attend[7] = False
                       appro[7] = False
                       suspect[1] = False
                       delay[2] = 0 
                       vel[7] += -0.2
                       spd[7] += -0.2
                       aipce = mvt[7] * 1 
                       frlst[7].setY(frlst[7], aipce * dt)
                       frlst[7].lookAt(self.pactor)
                       frlst[7].setP(0.0)
                       
                   if attend[7] and not suspect[1]:
                        if din > 4:
                           suspect[1] = True

                   if suspect[1] and not seen[7]:
                      vel[7] += -0.2
                      spd[7] += -0.2
                      aipce = mvt[7] / 8 * -1 
                      frlst[7].lookAt(self.atttar7)                         
                      frlst[7].setY(frlst[7], aipce * dt)
                      frlst[7].setH(frlst[7].getH() -180)
                      frlst[7].setP(0.0)                  

                   if appro[7]:
                      delay[2] += 1
                      if delay[2] > 100:
                          self.atttar7.setPos(0, 0, 0)
                          attend[7] = False
                          appro[7] = False
                          suspect[1] = False
                          delay[2] = 0                                                                         
        return Task.cont
    
    def fr04(self, task):
        global switch
        global grab
        global np
        global vel
        global spd
        global celerity
        global rneg
        global rpos
        global mvt
        global mag
        global sld
        global surfY
        global surZ
        global surfP
        global frict
        global surf
        global relp
        global frlst
        global slddel
        global crp
        global din
        global debug
        global charcrp
        global chase
        global suspect
        global suspected
        global suspos
        global delay
        global noise
        global attend
        global appro
        global seen
        global see
        global seqact
        global pathset
        global run
        if run:
# - Loading Handler -            
            if not switch[8] > 0:               
                frlst[8] = Actor("actor/opptest.egg", {"Walk": "actor/opptest-ani/opptest-Walk"})
                frlst[8].reparentTo(self.render) 
                self.oact8pos = self.scene.find("**/en03").getPos()
                frlst[8].setPos(self.oact8pos)
                frlst[8].setZ(frlst[8], +1.0)             
                self.oactor8cn = frlst[8].attachNewNode(CollisionNode('fr8'))            
                self.oactor8cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
                self.pusher.addCollider(self.oactor8cn, frlst[8])
                base.cTrav.addCollider(self.oactor8cn, self.pusher)            
                self.actvis8cn = frlst[8].attachNewNode(CollisionNode('vi8'))             
                self.actvis8 = CollisionTube(0, 0, 0.2, 0, -6.0, 0.2, 0.2)           
                self.actvis8.setTangible(0)           
                self.actvis8cn.node().addSolid(self.actvis8)
                self.selradius8 = CollisionSphere(0, 0, 0.0, 2.0)
                self.selradius8.setTangible(0)
                self.actvis8cn.node().addSolid(self.selradius8)            
                self.pusher.addCollider(self.actvis8cn, frlst[8])
                base.cTrav.addCollider(self.actvis8cn, self.pusher)           
                frlst[8].loop("Walk")
                self.atttar8 = NodePath(CollisionNode("atttar8"))
                self.atttar8.reparentTo(self.render)
                self.atttar8.setPos(0, 0, 0)
                self.attradius8 = CollisionSphere(0, 0, 0.2, 0.1)
                self.attradius8.setTangible(0)
                self.atttar8.node().addSolid(self.attradius8)
                self.seqtar8 = NodePath(CollisionNode("seqtar8"))
                self.seqtar8.reparentTo(self.render)
                self.seqtar8.setPos(0, 0, 0)
                self.seqpoint8 = CollisionSphere(0, 0, 0.2, 0.1)
                self.seqpoint8.setTangible(0)
                self.seqtar8.node().addSolid(self.seqpoint8)             
                charcrp[8] = -2
                switch[8] = 1
                if debug:
                    self.oactor8cn.show()
            else:
                if not switch[8] > 1:               
                   dt = globalClock.getDt()
# - Surface Handler -
                   if frict[8]:
                        frlst[8].headsUp(relp[8], surf[8])
                   else:
                        if surZ[8] > 7.7:               
                            frlst[8].headsUp(relp[8], surf[8])
                            slp = 0
                            rneg[8] = -0.1
                            rpos[8] = 0.1                    
                        else:
                            slddel[8] += 1
                            rneg[8] = -0.4
                            rpos[8] = 0.4                    
                            if slddel[8] > 3:
                                slddel[8] = 0
                                slp = surZ[8] - 7.0
                                spd[8] += abs(slp) * -1
                                vel[8] += abs(slp) * 1
                                if vel[8] > 0:
                                    vel[8] = 0   
               
# - Speed Handler (Regualator) -                    
                   if vel[8] is 0 and spd[8] is 0:
                        celerity[8] = True
                        vel[8] = 0
                        spd[8] = 0
                   else:
                        if rneg[8] <= vel[8] <= rpos[8]:
                            vel[8] = 0
                            if not rneg[8] <= spd[8] <= rpos[8]:
                               celerity[8] = False
                        else:
                            if vel[8] < 0:
                               vel[8] += 0.1
                            else:
                               vel[8] += -0.1           
                        if rneg[8] <= spd[8] <= rpos[8]:
                            spd[8] = 0
                            if not rneg[8] <= vel[8] <= rpos[8]:                
                               celerity[8] = True
                        else:
                            if spd[8] < 0:
                               spd[8] += 0.1
                            else:
                               spd[8] += -0.1

                   if celerity[8]:
                        mvt[8] = int(vel[8])
                   else:
                        mvt[8] = int(spd[8])          
                                        
# - Speed Handler (Limiter) -
                   if vel[8] < -6.0:
                       vel[8] += 0.3
                       if vel[8] < -6.5:
                          mag[8] = 0
                          if vel[8] < -8.0:
                             vel[8] = -8.0
                   else:
                       mag[8] = -5  

                   if spd[8] < -6.0:
                       spd[8] += 0.3
                       if spd[8] < -6.5:
                          mag[8] = 0
                          if spd[8] < -15.0:
                             spd[8] = -15.0
                   else:
                       mag[8] = -5

# - Speed Handler (Slider) -
                   if not celerity[8]:
                           frlst[8].setY(frlst[8], sld[8] * dt)
                           if not -0.5 <= surfY[8] <= 0.5: 
                               if surfY[8] > 0:
                                   sld[8] = spd[8] * -1
                               else:
                                   sld[8] = spd[8] * 1

                           if not surZ[8] > 7.7: 
                               frlst[8].lookAt(surfP[8])                     
                   
# - Gravity Handler -
                   skim = int(mom[8]) + int(mag[8])            
                   pace = skim + 1
                   rate = skim - 1
                   if pospos[8] <= frlst[8].getZ() <= prepos[8]:
                         prepos[8] = frlst[8].getZ() + (pace * dt)
                         pospos[8] = frlst[8].getZ() + (rate * dt)
                         frlst[8].setZ(frlst[8], skim * dt)
                         mom[8] += -0.2
                         if mom[8] < -7:
                             if mom[8] < -11:
                                mom[8] += 0.2
                                
                   else:
                         prepos[8] = frlst[8].getZ() + (pace * dt)
                         pospos[8] = frlst[8].getZ() + (rate * dt)
                         frlst[8].setZ(frlst[8], skim * dt)               
                         if mom[8] > 0:
                            mom[8] += -0.2
                         else:
                            mom[8] +=  0.2                      

# - AI Sequence (Sequence)-
                   see[8] = self.actvis8cn.node().getSolid(0)
                   if not suspect[2] and not attend[8] and not seen[8]: 
                       if pathset[8]:
                           self.seqtar8.setPos(0, 0, 0)
                           pathset[8] = False
                       else:                       
                           if seqact[8] is 0:
                              self.seqtar8.setPos(self.scene.find("**/col04").getPos())
                           if seqact[8] is 1:
                              self.seqtar8.setPos(self.scene.find("**/col05").getPos())
                           if seqact[8] is 2:
                              self.seqtar8.setPos(self.scene.find("**/plat01").getPos())
                           if seqact[8] is 3:
                              self.seqtar8.setPos(self.scene.find("**/en03").getPos())
                           if seqact[8] is 4:
                              seqact[8] = 0
                          
                   if not suspect[2]:
                           if delay[3] is 0:
                               self.atttar8.setPos(noise)

                   if not suspect[2] and not attend[8] and not seen[8]:                   
                      vel[8] += -0.2
                      spd[8] += -0.2
                      aipce = mvt[8] / 4 * -1                  
                      frlst[8].lookAt(self.seqtar8)                         
                      frlst[8].setY(frlst[8], aipce * dt)
                      frlst[8].setH(frlst[8].getH() -180)
                      frlst[8].setP(0.0)                
                       
                   if seen[8]:
                       attend[8] = False
                       appro[8] = False
                       suspect[2] = False
                       delay[3] = 0 
                       vel[8] += -0.2
                       spd[8] += -0.2
                       aipce = mvt[8] /2 * 1 
                       frlst[8].setY(frlst[8], aipce * dt)
                       frlst[8].lookAt(self.pactor)
                       frlst[8].setH(frlst[8].getH() -180)
                       frlst[8].setP(0.0)
                       
                   if attend[8] and not suspect[2]:
                        if din > 4:
                           suspect[2] = True

                   if suspect[2] and not seen[8]:
                      vel[8] += -0.2
                      spd[8] += -0.2
                      aipce = mvt[8] / 8 * -1 
                      frlst[8].lookAt(self.atttar8)                         
                      frlst[8].setY(frlst[8], aipce * dt)
                      frlst[8].setH(frlst[8].getH() -180)
                      frlst[8].setP(0.0)                  

                   if appro[8]:
                      delay[3] += 1
                      if delay[3] > 100:
                          self.atttar8.setPos(0, 0, 0)
                          attend[8] = False
                          appro[8] = False
                          suspect[2] = False
                          delay[3] = 0                

        return Task.cont

    def fr05(self, task):
        global switch
        global grab
        global np
        global vel
        global spd
        global celerity
        global rneg
        global rpos
        global mvt
        global mag
        global sld
        global surfY
        global surZ
        global surfP
        global frict
        global surf
        global relp
        global frlst
        global slddel
        global crp
        global din
        global debug
        global charcrp
        global chase
        global suspect
        global suspected
        global suspos
        global delay
        global noise
        global attend
        global appro
        global seen
        global see
        global seqact
        global pathset
        global wondel
        global pid
        global wontrn
        global pseed1
        global pseed2
        global perimeter
        global run
        if run:
# - Loading Handler -            
            if not switch[9] > 0:               
                frlst[9] = Actor("actor/opptest.egg", {"Walk": "actor/opptest-ani/opptest-Walk"})
                frlst[9].reparentTo(self.render) 
                self.oact9pos = self.scene.find("**/en04").getPos()
                frlst[9].setPos(self.oact9pos)
                frlst[9].setZ(frlst[9], +1.0)             
                self.oactor9cn = frlst[9].attachNewNode(CollisionNode('fr9'))            
                self.oactor9cn.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
                self.pusher.addCollider(self.oactor9cn, frlst[9])
                base.cTrav.addCollider(self.oactor9cn, self.pusher)            
                self.actvis9cn = frlst[9].attachNewNode(CollisionNode('vi9'))             
                self.actvis9 = CollisionTube(0, 0, 0.2, 0, -6.0, 0.2, 0.2)           
                self.actvis9.setTangible(0)           
                self.actvis9cn.node().addSolid(self.actvis9)
                self.selradius9 = CollisionSphere(0, 0, 0.0, 2.0)
                self.selradius9.setTangible(0)
                self.actvis9cn.node().addSolid(self.selradius9)            
                self.pusher.addCollider(self.actvis9cn, frlst[9])
                base.cTrav.addCollider(self.actvis9cn, self.pusher)           
                frlst[9].loop("Walk")
                self.atttar9 = NodePath(CollisionNode("atttar9"))
                self.atttar9.reparentTo(self.render)
                self.atttar9.setPos(0, 0, 0)
                self.attradius9 = CollisionSphere(0, 0, 0.2, 0.1)
                self.attradius9.setTangible(0)
                self.atttar9.node().addSolid(self.attradius9)
                self.perim9 = NodePath(CollisionNode("pe9"))
                self.perim9.reparentTo(self.render)
                self.perim9.setPos(self.oact9pos)
                self.circum9 = CollisionSphere(0, 0, 0, 8.0)
                self.circum9.setTangible(0)
                self.perim9.node().addSolid(self.circum9)             
                charcrp[9] = -2
                switch[9] = 1
                if debug:
                    self.oactor9cn.show()
            else:
                if not switch[9] > 1:               
                   dt = globalClock.getDt()
# - Surface Handler -
                   if frict[9]:
                        frlst[9].headsUp(relp[9], surf[9])
                   else:
                        if surZ[9] > 7.7:               
                            frlst[9].headsUp(relp[9], surf[9])
                            slp = 0
                            rneg[9] = -0.1
                            rpos[9] = 0.1                    
                        else:
                            slddel[9] += 1
                            rneg[9] = -0.4
                            rpos[9] = 0.4                    
                            if slddel[9] > 3:
                                slddel[9] = 0
                                slp = surZ[9] - 7.0
                                spd[9] += abs(slp) * -1
                                vel[9] += abs(slp) * 1
                                if vel[9] > 0:
                                    vel[9] = 0   
               
# - Speed Handler (Regualator) -                    
                   if vel[9] is 0 and spd[9] is 0:
                        celerity[9] = True
                        vel[9] = 0
                        spd[9] = 0
                   else:
                        if rneg[9] <= vel[9] <= rpos[9]:
                            vel[9] = 0
                            if not rneg[9] <= spd[9] <= rpos[9]:
                               celerity[9] = False
                        else:
                            if vel[9] < 0:
                               vel[9] += 0.1
                            else:
                               vel[9] += -0.1           
                        if rneg[9] <= spd[9] <= rpos[9]:
                            spd[8] = 0
                            if not rneg[9] <= vel[9] <= rpos[9]:                
                               celerity[9] = True
                        else:
                            if spd[9] < 0:
                               spd[9] += 0.1
                            else:
                               spd[9] += -0.1

                   if celerity[9]:
                        mvt[9] = int(vel[9])
                   else:
                        mvt[9] = int(spd[9])          
                                        
# - Speed Handler (Limiter) -
                   if vel[9] < -6.0:
                       vel[9] += 0.3
                       if vel[9] < -6.5:
                          mag[9] = 0
                          if vel[9] < -8.0:
                             vel[9] = -8.0
                   else:
                       mag[9] = -5  

                   if spd[9] < -6.0:
                       spd[9] += 0.3
                       if spd[9] < -6.5:
                          mag[9] = 0
                          if spd[9] < -15.0:
                             spd[9] = -15.0
                   else:
                       mag[9] = -5

# - Speed Handler (Slider) -
                   if not celerity[9]:
                           frlst[9].setY(frlst[9], sld[9] * dt)
                           if not -0.5 <= surfY[9] <= 0.5: 
                               if surfY[9] > 0:
                                   sld[9] = spd[9] * -1
                               else:
                                   sld[9] = spd[9] * 1

                           if not surZ[9] > 7.7: 
                               frlst[9].lookAt(surfP[9])                     
                   
# - Gravity Handler -
                   skim = int(mom[9]) + int(mag[9])            
                   pace = skim + 1
                   rate = skim - 1
                   if pospos[9] <= frlst[9].getZ() <= prepos[9]:
                         prepos[9] = frlst[9].getZ() + (pace * dt)
                         pospos[9] = frlst[9].getZ() + (rate * dt)
                         frlst[9].setZ(frlst[9], skim * dt)
                         mom[9] += -0.2
                         if mom[9] < -7:
                             if mom[9] < -11:
                                mom[9] += 0.2
                                
                   else:
                         prepos[9] = frlst[9].getZ() + (pace * dt)
                         pospos[9] = frlst[9].getZ() + (rate * dt)
                         frlst[9].setZ(frlst[9], skim * dt)               
                         if mom[9] > 0:
                            mom[9] += -0.2
                         else:
                            mom[9] +=  0.2                      

# - AI Sequence (Wander)-
                   edge[9] = self.perim9.node().getSolid(0)
                   if pid[9] > 9:
                       pid[9] = 9
                   else:    
                       pid[9] = rng * 1 #(1: all), (2: 1st 4), (3: 1st 3), (4: 1st 2)
                       
                   if perimeter[9]:
                       if wontrn[9]:
                          tur = rng * 10
                          if wondel[9] > 0:
                              if pseed1[9] > pid[9]:
                                 frlst[9].setH(frlst[9].getH() - tur * dt)
                                 wondel[9] -= 1
                              else:
                                 frlst[9].setH(frlst[9].getH() + tur * dt)
                                 wondel[9] -= 1
                          else:
                              pseed1[9] = rng                         
                              wondel[9] = rng * 10                           
                              wontrn[9] = False
                       
                       else:
                          if wondel[9] > 0: 
                              vel[9] += -0.2
                              spd[9] += -0.2
                              if pseed2[9] > pid[9]:
                                  aipce = mvt[9] / 4 * 1                  
                                  frlst[9].setY(frlst[9], aipce * dt)
                                  wondel[9] -= 1                              
                              else:
                                  aipce = mvt[9] / 4 * -1                  
                                  frlst[9].setY(frlst[9], aipce * dt)
                                  wondel[9] -= 1                              
                          else:
                              pseed2[9] = rng                         
                              wondel[9] = rng * 10                           
                              wontrn[9] = True                          

                   else:         
                       vel[9] += -0.2
                       spd[9] += -0.2
                       aipce = mvt[9] /2 * -1 
                       frlst[9].setY(frlst[9], aipce * dt)
                       frlst[9].lookAt(self.perim9)
                       frlst[9].setH(frlst[9].getH() -180)
                       frlst[9].setP(0.0)


        return Task.cont
    
# Into Objects ***
    def sign(self, entry):
        global iactline0
        global iactline1
        global iactline2
        global iactline3
        global iactline
        global inactobj
        global interact
        global iaforward
        global iaup
        global inactset
        global iactend
        global interacting
        global run
        if run:
            if not interacting:
                iaforward = self.render.getRelativePoint(self.pobject, (0, 1, 0))
                iaup = entry.getSurfaceNormal(self.render)
                iactline0 = "Hello world! or should I say you, freind! <cont: J>"
                iactline1 = "This is a milestone for my creator as He got <cont: J>"
                iactline2 = "This feature to work! but yeah, this a test sign <cont: J>"
                iactline3 = "Testing Panda3d text functions! oh boy!"
                interact = True
                inactobj = True
                iactend = 4

    def in02(self, task):
        global frlst
        global switch
        global tou
        global charcrp
        global mom
        global soar
        global run
        if run:
# - Loading Handler -            
            if not switch[3] > 0:               
                frlst[3] = Actor("actor/itmbox.egg")
                frlst[3].reparentTo(self.render)           
                self.oact2pos = self.scene.find("**/col01").getPos()
                frlst[3].setPos(self.oact2pos)
                self.obj1 = frlst[3].attachNewNode(CollisionNode('fr3'))
                self.obj1.node().addSolid(CollisionSphere(0, 0, 0.3, 0.3))
                self.pusher.addCollider(self.obj1, frlst[3])
                charcrp[3] = 0
                switch[3] = 1
            else:
                if not switch[3] > 1:               
# - Finished State -                                 
                    if tou[3]:
                        mom[0] += 11.0
                        soar = True
                        frlst[3].stash()
                        switch[3] = 2
                        tou[3] = False

        return Task.cont

    def in03(self, task):
        global frlst
        global switch
        global tou
        global delay
        global charcrp
        global run
        if run:
# - Loading Handler -            
            if not switch[4] > 0:               
                frlst[4] = Actor("actor/platform.egg")
                frlst[4].reparentTo(self.render)           
                self.oact3pos = self.scene.find("**/col02").getPos()
                frlst[4].setPos(self.oact3pos)
                frlst[4].setZ(1.0)
                frlst[4].find("**/platform").node().setName('fr4')
                charcrp[4] = 0
                switch[4] = 1
            else:
                if not switch[4] > 1:               
# - Sequance State -                                 
                    if tou[4]:
                       switch[4] = 2
                else:
# - Finshed State -                
                    if not switch[4] > 2:
                       dt = globalClock.getDt()                    
                       frlst[4].setZ(frlst[4], -0.3 * dt)
                       delay[0] += 1
                       if delay[0] is 80:
                          frlst[4].stash()
                          tou[4] = False
                          delay[0] = 0
                          switch[4] = 3
                    
        return Task.cont

    def in04(self, task):
        global frlst
        global switch
        global sequence
        global charcrp
        global run
        if run:
# - Loading Handler -            
            if not switch[5] > 0:               
                frlst[5] = Actor("actor/platform.egg")
                frlst[5].reparentTo(self.render)           
                self.oact4pos = self.scene.find("**/col03").getPos()
                frlst[5].setPos(self.oact4pos)
                frlst[5].setZ(1.0)
                frlst[5].find("**/platform").node().setName('fr5')
                charcrp[5] = 0
                switch[5] = 1
            else:              
# - Sequance State -                                 
                dt = globalClock.getDt()
                if sequence[0] is 1:
                    frlst[5].setZ(frlst[5], -0.9 * dt)
                    if frlst[5].getZ() < 0.5:
                       sequence[0] = 0
                if sequence[0] is 0:                   
                    frlst[5].setZ(frlst[5], 0.9 * dt)
                    if frlst[5].getZ() > 8.0:
                       sequence[0] = 1


        return Task.cont

    def in05(self, task):
        global frlst
        global switch
        global charcrp
        global run
        if run:
# - Loading Handler -            
            if not switch[6] > 0:               
                frlst[6] = Actor("actor/platform.egg")
                frlst[6].reparentTo(self.render)           
                self.oact5pos = self.scene.find("**/col04").getPos()
                frlst[6].setPos(self.oact5pos)
                frlst[6].setZ(2.0)
                frlst[6].find("**/platform").node().setName('fr6')
                charcrp[6] = 0
                switch[6] = 1
            else:              
# - Sequance State -                                 
                dt = globalClock.getDt()
                frlst[6].setP(frlst[6], -18.0 * dt)

        return Task.cont
    
    def dummydelay(self, task):
           global dummydel
           global interacting
           global interact
           global iactend
           global tspd
           global dumcom
           global iactline0
           global iactline1
           global iactline2
           global iactline3
           global iactline4
           global iactline5
           global iactline6
           global iactline7
           global iactline8
           global iactline9
           global run

           if run:
               if not interacting:
                  if not dummydel > 600:
                       dummydel += 1
                  else:
                       if not dumcom:
                           iactline0 = "Well, hello world! or should I say you, freind! so 10"
                           iactline1 = "seconds have passed huh? well what you are looking at is"
                           iactline2 = "a conversation while action is taking place, this will be"
                           iactline3 = "used best for boss battles when they need to say something"
                           iactline4 = "like right now, Oh hi player! I see you and you can't see"
                           iactline5 = "me! but do not worry I'am here just to talk, like how this"
                           iactline6 = "is a test conversation using Panda3d's text feature to"
                           iactline7 = "display text, now what to say? hmmm.. hmmm... hmmm!!!!"
                           iactline8 = "well, let me think about this after dinner *Leaves Room*" 
                           iactline9 = "*Comes Back* oh! we are at the end, oops sorry! next time!"
                           iactend = 10
                           tspd = -120
                           textdel = -120
                           interact = True
                           interacting = True
                           dumcom = True
              
           return Task.cont            

# Surfaces ***
    def surface(self, entry):
        global frict
        global land
        global bump
        global vel
        global spd
        global surfP
        global surfY
        global surZ
        global slddel
        global rpos
        global rneg
        global relp
        global surf
        global surcrp
        global run
        if run:
            relp[0] = self.render.getRelativePoint(self.pobject, (0, 1, 0))
            surf[0] = entry.getSurfaceNormal(self.render)
            surfY[0] = entry.getSurfaceNormal(self.pactor).getY()
            surfP[0] = entry.getSurfacePoint(self.render)        
            surZ[0] = entry.getSurfaceNormal(self.render).getZ()
            surX = entry.getSurfaceNormal(self.render).getX()
            surY = entry.getSurfaceNormal(self.render).getY()

            if not swimming:
                if surZ[0] < 6.0:
                   land = False
                else:
                   land = True

                if abs(surX) > 3.5 or abs(surY) > 3.5:
                    bump = True
                else:
                    bump = False
                    
                if frict[0]:
                    self.pobject.headsUp(relp[0], surf[0])
                else:
                    if surZ[0] > 7.7:               
                        self.pobject.headsUp(relp[0], surf[0])
                        slp = 0
                        rneg[0] = -0.1
                        rpos[0] = 0.1                    
                    else:
                        slddel[0] += 1
                        rneg[0] = -0.4
                        rpos[0] = 0.4                    
                        if slddel[0] > 3:
                            slddel[0] = 0
                            slp = surZ[0] - 7.0
                            spd[0] += abs(slp) * -1
                            vel[0] += abs(slp) * 1
                            if vel[0] > 0:
                                vel[0] = 0
            surcrp = 1
        
# sneaking merchanics will have code record the surface point everytime a step
# is made (a delay system with getsurfacepoint code into a varibale), based
# on another varible which is calualted from numbers given based on character
# and action, when said number is met, the enemies lookAt code will look at the
# recored surfacepoint's X and Y components while padding the Z with it's own
# vision can be implemented using a collsion ray, that if touches you the enemy
# sees you.
    def frsurf(self, entry):
        global relp
        global surf
        global surfY
        global surfP
        global surZ
        global frlst
        global charcrp
        global crp
        global tap
        global run
        if run:
            frids = re.compile('\d+(?:\.\d+)?')
            frid = frids.findall(str(entry.getFromNodePath()))         
            relp[int(frid[0])] = self.render.getRelativePoint(frlst[int(frid[0])], (0, 1, 0))
            surf[int(frid[0])] = entry.getSurfaceNormal(self.render)
            surfY[int(frid[0])] = entry.getSurfaceNormal(frlst[int(frid[0])]).getY()
            surfP[int(frid[0])] = entry.getSurfacePoint(self.render)        
            surZ[int(frid[0])] = entry.getSurfaceNormal(self.render).getZ()
            crp[int(frid[0])] = charcrp[int(frid[0])] + 2
            tap[int(frid[0])] = 2
                      
 
    
#this calls the preconstructed loop from panda3d engine instead of wrtting one.
app = gamesys ()
app.run()

# setP(X.X) = to tilt the model, setH(X.X) = rotates the model, setR(X.X) =
# pans the model in a pi (circle) degree angle.
# activate panda's placer mode
# def place (self):
#           base.startDirect(fWantTk = 1)
#           from direct.tkpanels import Placer
#           return Placer.place(self)
#------------------------------------------------------------------------------
# Python is basically using a calculator but you can label the numbers with a
# name, a number labeled under a name is called a “Integer”, now from the basic
# calculator commands there are additional ones that use names and other symbols
# for more manipulation, see command list below for their effects, a command can
# also be labeled just like a number, a command under a label is called a
# “Variable”, to label a number or command, you type in anything but a number
# alone, first, or a command name, then after that, a equal (=), then the number
# or command.

# Command List- - - - -

# = (equal sign): it does not do what it would do on a calculator, instead,
# whatever is after this becomes that of whatever is before this, if a number
# becomes a name, it is a integer, if a non number became a name, it is a
# variable,names cannot start with numbers but can end with numbers.

# + (Plus): addition with numbers labeled or not, but when dealing with commands
# label or not, it combines those commands involved, all each needing their own
# plus.

# - (Minus): subtraction with numbers labeled or not.

# * (Star, Multiply): does what the “X” on a calculator does, multiplication
# with numbers labeled or not.

# / (Slash, Division): does what the “Straight Percent Symbol” does on a
# calculator, division with numbers labeled or not.

# % (percent, modulus): it does not do what the percent would do on a calculator
# instead, it gives the difference from the division of a uneven division of
# numbers.

# print(): does what the equal (=) on a calculator does, and that is inject the
# “Result” of whatever is within the parentheses after this word into the
# standard output which is by default the console or screen (window).
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# script written by J.N. Pickee
